function Array(size,value)
	local array = {}
	for i = 1, size do
		array[i]=value
	end
	return array
end

function totable(t,match)
	local cmd = {}
	if not match then match = "[^%s]+" end
	for word in string.gmatch(t, match) do
		table.insert(cmd, word)
	end 
	return cmd 
end

function belongs_to_table(t,value)
    for i=1,#t do
        if t[i]==value then
            return true
        end
    end
    return false
end

function rv_msg2(id,clr,txt)
	msg2(id,c..""..clr..""..txt)
end

function rv_msg(clr,txt)
	for _,id in pairs(player(0,"table")) do
	rv_msg2(id,clr,txt)
	end
end


function hudtext2(id,tid,color,txt,x,y)
     local toprint = (c..""..color.." "..txt)
     parse('hudtxt2 '..id..' '..tid..' "'..toprint..'" '..x.." "..y)
end

function hudtext(tid,color,txt,x,y)
     local toprint = (c..""..color.." "..txt)
     parse('hudtxt '..tid..' "'..toprint..'" '..x.." "..y)
end

function removeitem(itemid)
	parse("removeitem "..itemid)
end

function Restore(id)
mouse_event[id]=0
name_dly[id]=0
rv_fireball[id]=false
rv_fireballs[id]=0
rv_clan[id]=0
rv_clanp[id]=0
rv_hppup[id]=0
rv_defup[id]=0
rv_dmgup[id]=0
rv_level[id]=1
rv_exp[id]=0
rv_expp[id]=1080
rv_gold[id]=0
rv_food[id]=0
rv_wood[id]=0
rv_stone[id]=0
rv_vip[id]=false
rv_vipmsg[id]=0
rv_admin[id]=0
rv_admina[id]=false
rv_color[id]=0
rv_tilex[id]=0
rv_tiley[id]=0
rv_hat[id]=0
rv_hats[id]=nil
rv_horse[id]=0
rd_horse[id]=0
rv_horses[id]=nil
rv_horsed[id]=0
rv_weapon[id]=0
rv_sword[id]=0
rv_sworda[id]=0
rv_bow[id]=0
rv_bowi[id]=nil
rv_damage[id]=100
rv_defence[id]=10
rv_matk[id]=0
rv_mdef[id]=0
rv_attribute[id]=0
rv_eightgates[id]=0
rv_reincarnation[id]=0
rv_classn[id]="Academy Student"
rv_class[id]=0
rv_speedmod[id]=0
rv_point[id]=0
rv_mute[id]=0
rv_bank[id]=0
rv_bankname[id]="Nothing"
rv_bankmax[id]=10000000
rv_balance[id]=0
rv_berry[id]=0
rv_treasure[id]=0
rv_bones[id]=0
rv_relic[id]=0
rv_dragon[id]=0
rv_pegasus[id]=0
rv_iron[id]=0
rv_diamond[id]=0
rv_redcrys[id]=0
rv_ticket[id]=0
rv_axure[id]=0
rv_spent[id]=0
rv_gain[id]=0
rv_dexp[id]=0
rv_dgold[id]=0
rv_sworddmg[id]=0
rv_gacha[id]=0
rv_jail[id]=0
rv_energy[id]=0
rv_axure[id]=0
rv_maxenergy[id]=0
rv_energys[id]=0
rv_speedred[id]=0
rv_passout[id]=0
rv_spcchat[id]=0
rv_spcuser[id]=false
rv_spccolor[id]="000127255"
rv_spctime[id]=0
rv_spctel[id]=0
rv_spctele[id]=0
rv_spcset[id]=0
rv_fish[id]=0
rv_fishing[id]=0
rv_fishstate[id]=0
rv_rod[id]=false
rv_bait[id]=0
rv_hp[id]=0
rv_hpp[id]=1000
rv_snow[id]=false
rv_kyubi[id]=false
rv_kyubitime[id]=0
rv_kyubii[id]=nil
rv_kyubii1[id]=nil
rv_kyubiid[id]=0
rv_citron[id]=false
rv_citrons[id]=0
rv_layered[id]=false
rv_layereds[id]=0
rv_vulcan[id]=false
rv_vulcans[id]=0
rv_gale[id]=false
rv_stdust[id]=false
rv_stdusttime[id]=0
rv_shar[id]=false
rv_shartime[id]=0
rv_shari[id]=nil
rv_sharii[id]=nil
rv_sharx[id]=0
rv_shary[id]=0
rv_sharrot[id]=0
rv_shariid[id]=0
rv_sharstate[id]=0
rv_stinger[id]=false
rv_sting[id]=0
rv_gold_type[id]=68
rv_gold_drop[id]=0
rv_xa[id]=0
rv_ya[id]=0
rv_freetree[id]=0
rv_nospam[id]=0
rv_pickup[id]=0
rv_hitm4a1[id]=0
rv_warliker[id]=0
rv_usgnid[id]=0
rv_error[id]=false
rv_cash[id]=0
rv_drunk[id]=0
rv_menupop[id]=0
rv_godmod[id]=false
rv_gods[id]=nil
rv_spawned[id]=0
rv_pburstimg[id]=nil
rv_pet[id]=0
rv_pets[id]="Nothing"
rv_petimg[id]=nil
rv_petx[id]=0
rv_pety[id]=0
rv_petsk[id]=0
rv_rasen[id]=false
rv_rasens[id]=0
rv_rasened[id]=0
rv_rasenimg[id]=nil
rv_rasenrot[id]=0
rv_kiri[id]=false
rv_kiris[id]=0
rv_team[id]=0
rv_wallhack[id]=0
rv_reinlimit[id]=0
vk_votime[id]=0
rv_tero[id]=false
rv_defup[id]=0
rv_dmgup[id]=0
rv_dark[id]=0
rv_qcomp[id]=false
rv_qmsg[id]=false
rv_qprog[id]=0
rv_qid[id]=1
rv_qreq[id]=0
rv_qname[id]=""
rv_gnosis[id]=false
rv_gnoimg[id]=nil
rv_gnosist[id]=0
rv_vulcansh[id]=false
rv_wing[id]=false
rv_wings[id]=nil
rv_wingsh[id]=false
rv_wingsh1[id]=false
rv_spec[id]=0
rv_pm[id]=0
rv_aquas[id]=0
rv_natures[id]=0
rv_violets[id]=0
rv_darks[id]=0
rv_kirix[id]=0
rv_kiriy[id]=0
rv_st[id]=0
rv_clay[id]=0
local UsgnID=rv_usgnid[id]
rv_donator[id]=isDonator(UsgnID)
rv_spcuser[id]=isPrem(UsgnID)
rv_admin[id]=isAdmin(UsgnID)
if rv_admin[id]>0 then
rv_admina[id]=true
rv_vip[id]=true
rv_color[id]=1
end
end

function ExpHud(id)
	if id~=nil then
		hudtext2(id,2,"140023023","Exp:"..rv_exp[id].."/"..rv_expp[id],170,465)
	end
end

function GoldHud(id)
	if id~=nil then
		if rv_gold[id]>=100000 then
			gg=2
		elseif rv_gold[id]>=10000 then
			gg=1
		else
			gg=0
		end
		if rv_gold[id]>=1000 then
		hudtext2(id,3,"150069020","Gold: "..string.sub(rv_gold[id],1,1+gg).."."..string.sub(rv_gold[id],2+gg,4+gg),300,445)
		else
		hudtext2(id,3,"150069020","Gold: "..rv_gold[id],300,445)
		end
	end
end

function LevelHud(id)
	if id~=nil then
		hudtext2(id,4,"073129206","Level:"..rv_level[id].."/100",170,445)
	end
end

function EnergyHud(id)
	if id~=nil then
		hudtext2(id,9,"010100255","Chakra: "..rv_energy[id].."/"..rv_maxenergy[id],300,465)
	end
end

function CashHud(id)
	if id~=nil then
		hudtext2(id,36,"175070010","Burst Point: "..rv_cash[id],15,110)
	end
end

tim1=0
tim2=0

timehsv=7

servertime=0
timenewhour=0
timenewminute=0
timenew=0

servertime1=0
timenewhour1=0
timenewminute1=0
timenew1=0

tim11=0
tim1=0
tim2=0

-- Time e.g.: 04:36 pm
--if (txt=="time") then msg(os.date("Time: %I:%M %p")); end

-- Date e.g.: Wednesday, 25 Feb 2009
--if (txt=="date") then msg(os.date("Date: %A, %d %b %Y")); end

function TimeHud()
if os.date("%p")=="PM" then
servertime=((((os.date("%I")+12)*60)+os.date("%M"))*60)+os.date("%S")
else
servertime=(((os.date("%I")*60)+os.date("%M"))*60)+os.date("%S")
end
timenewhour=(timehsv*60)*60
timenewminute=0
timenew=(servertime+timenewhour)+timenewminute
if timenew>86400 then
timenew=timenew-86400
elseif timenew<0 then
timenew=timenew+86400
end
----
if os.date("%p")=="PM" then
servertime1=((((os.date("%I")+12)*60)+os.date("%M"))*60)+os.date("%S")
else
servertime1=(((os.date("%I")*60)+os.date("%M"))*60)+os.date("%S")
end
timenewhour1=((timehsv-1)*60)*60
timenewminute1=0
timenew1=(servertime1+timenewhour1)+timenewminute1
if timenew1>86400 then
timenew1=timenew1-86400
elseif timenew1<0 then
timenew1=timenew1+86400
end
local tim11 = math.floor((timenew1 / 60) / 60)
----
local tim1 = math.floor((timenew / 60) / 60)
local tim2 = math.floor((timenew / 60)-(math.floor((timenew / 60)/ 60)*60))
if tim11==18 then tim1=7 end
if tim11==6 then tim1=19 end
if tim1<10 then nol="0" else nol="" end
if tim2<10 then nol1="0" else nol1="" end
hudtext(24,"075170210","Server Time: "..c.."255255000[ "..nol..""..tim1..":"..nol1..""..tim2.." ]",0,55)
end

function HurtHud(id,src)
	if id~=nil and src~=nil then
		hudtext2(src,20,"200200200",player(id,"name").."'s HP left: "..math.floor(rv_hp[id]).."/"..math.floor(rv_hpp[id]),330,395)
		parse('hudtxtalphafade '..src..' 20 8000 0.0')
		hudtext2(id,20,"200200200",player(src,"name").."'s HP left: "..math.floor(rv_hp[src]).."/"..math.floor(rv_hpp[src]),330,395)
		parse('hudtxtalphafade '..id..' 20 8000 0.0')
	end
end

function VulcanHud(id)
	if id~=nil and rv_vulcan[id]==true then
		if rv_vulcansh[id]==true then
			vul="[ON]"
		else
			vul="[OFF]"
		end
		hudtext2(id,23,"255120100",""..vul.."Vulcan Ammo: "..rv_vulcans[id].."/500",430,445)
	end
end

function KyubiHud(id)
	if id~=nil then
		aa=" "
		bb=" "
		cc=" "
		dd=" "
		ee=" "
		ff=" "
		gg=" "
		hh=" "
		ii=" "
		jj=" "
		kk=" "
		ll=" "
		mm=" "
		nn=" "
		oo=" "
		if rv_kyubitime[id]>=30 then oo="|" end
		if rv_kyubitime[id]>=28 then nn="|" end
		if rv_kyubitime[id]>=26 then mm="|" end
		if rv_kyubitime[id]>=24 then ll="|" end
		if rv_kyubitime[id]>=22 then kk="|" end
		if rv_kyubitime[id]>=20 then jj="|" end
		if rv_kyubitime[id]>=18 then ii="|" end
		if rv_kyubitime[id]>=16 then hh="|" end
		if rv_kyubitime[id]>=14 then gg="|" end
		if rv_kyubitime[id]>=12 then ff="|" end
		if rv_kyubitime[id]>=10 then ee="|" end
		if rv_kyubitime[id]>=8 then dd="|" end
		if rv_kyubitime[id]>=6 then cc="|" end
		if rv_kyubitime[id]>=4 then bb="|" end
		if rv_kyubitime[id]>=2 then aa="|" end
		hudtext2(id,15,"200100000","Kyubi Time: ["..aa..""..bb..""..cc..""..dd..""..ee..""..ff..""..gg..""..hh..""..ii..""..jj..""..kk..""..ll..""..mm..""..nn..""..oo.."]",430,465)
	end
end

function JailHud(id)
	if id~=nil then
		if rv_jail[id]>=60 then
			minute=math.floor(rv_jail[id]/60)
			second=rv_jail[id]-(minute*60)
			hudtext2(id,10,"255010100","Jail Time:"..minute.." Minute(s), "..second.." Second(s)",0,180)
		elseif rv_jail[id]==-1 then
			hudtext2(id,10,"255010100","Jail Time: Permanently",0,180)
		else
			hudtext2(id,10,"255010100","Jail Time:"..rv_jail[id].." Second(s)",0,180)
		end
	end
end

function HpHud(id)
	if id~=nil then
		local hp=math.floor((rv_hp[id]/rv_hpp[id])*100)
		local hpp=0
		if hp<100 then hpp=5 end
		if hp<10 then hpp=10 end
		hudtext2(id,14,"255010100","Health:"..math.floor(rv_hp[id]).."/"..math.floor(rv_hpp[id]),15,460)
		if player(id,"health")>0 then
			if rv_tempgod[id]>=2 then
			hudtext2(id,29,"255255255","SAFE FOR "..rv_tempgod[id]-1,280,200)
			elseif rv_tempgod[id]==1 then
			hudtext2(id,29,"255255255","SAFE EXPIRED",275,200)
			else
			hudtext2(id,29,"255010100","HP:"..hp.."%",(295+hpp),200)
			end
		else
			hudtext2(id,29,"255010100","",0,0)
		end
	end
end

function DonatorHud(id)
	if id~=nil then
		hudtext2(id,25,"100010250","[Donator]Thank you for donating!",200,430)
	end
end

function radiussound(sound, x, y, radiusx, radiusy)
	if not (radiusx and radiusy) then radiusx, radiusy = 320, 240 end
	local x1, y1, x2, y2 = x-radiusx, y-radiusy, x+radiusx, y+radiusy
	for _, v in ipairs(player(0, 'table')) do
		if player(v, 'x') >= x1 and player(v, 'x') <= x2 and player(v, 'y') >= y1 and player(v, 'y') <= y2 then
			parse("sv_sound2 " .. v .. " " .. sound)
		end
	end
	return 1
end

function radiusmsg(words, x, y, radiusx, radiusy)
	print(words)
	if not (radiusx and radiusy) then radiusx, radiusy = 320, 240 end
	local x1, y1, x2, y2 = x-radiusx, y-radiusy, x+radiusx, y+radiusy
	for _, v in ipairs(player(0, 'table')) do
		if player(v, 'x') >= x1 and player(v, 'x') <= x2 and player(v, 'y') >= y1 and player(v, 'y') <= y2 then
			msg2(v,words)
		end
	end
	return 1
end

function inven1(id)
if rv_food[id]>=1 then
	food="(Food ["..rv_food[id].."])"
else
	food=""
end
if rv_wood[id]>=1 then
	wood="(Wood ["..rv_wood[id].."])"
else
	wood=""
end
if rv_stone[id]>=1 then
	stone="(Stone ["..rv_stone[id].."])"
else
	stone=""
end
if rv_bones[id]>=1 then
	bones="(Dead Monster Bones ["..rv_bones[id].."])"
else
	bones=""
end
if rv_treasure[id]>=1 then
	treasure="Treasure Chest ["..rv_treasure[id].."]|Click to open"
else
	treasure=""
end
if rv_berry[id]>=1 then
	berry="(Berry ["..rv_berry[id].."])"
else
	berry=""
end
if rv_axure[id]>=1 then
	axure="(Axure Relic ["..rv_axure[id].."])"
else
	axure=""
end
	menu(id,"Inventory - 1@b,"..food..","..wood..","..stone..","..bones..","..berry..","..treasure..","..axure..",Last|->>,Next|->")
end
function inven2(id)
if rv_iron[id]>=1 then
	iron="(Iron ["..rv_iron[id].."])"
else
	iron=""
end
if rv_diamond[id]>=1 then
	diamond="(Diamond ["..rv_diamond[id].."])"
else
	diamond=""
end
if rv_redcrys[id]>=1 then
	redcrys="(Red Crystal ["..rv_redcrys[id].."])"
else
	redcrys=""
end
if rv_aquas[id]>=1 then
	aquas="(Aqua Spirit ["..rv_aquas[id].."])"
else
	aquas=""
end
if rv_natures[id]>=1 then
	natures="(Nature Spirit ["..rv_natures[id].."])"
else
	natures=""
end
if rv_violets[id]>=1 then
	violets="(Violet Spirit ["..rv_violets[id].."])"
else
	violets=""
end
if rv_darks[id]>=1 then
	darks="(Dark Shadow Spirit ["..rv_darks[id].."])"
else
	darks=""
end
menu(id,"Inventory - 2@b,"..iron..","..diamond..","..redcrys..","..aquas..","..natures..","..violets..","..darks..",Prev|<-,Next|->")
end
function inven3(id)
if rv_dragon[id]>=1 then
	dragon="Rare Dragon Egg ["..rv_dragon[id].."]|Click to hatch"
else
	dragon=""
end
if rv_pegasus[id]>=1 then
	pegasus="Golden Pegasus Egg ["..rv_pegasus[id].."]|Click to hatch"
else
	pegasus=""
end
if rv_dark[id]>=1 then
	dark="Little Dark Egg ["..rv_dark[id].."]|Click to hatch"
else
	dark=""
end
if rv_clay[id]>=1 then
	clay="Clay Bird Egg ["..rv_clay[id].."]|Click to hatch"
else
	clay=""
end
menu(id,"Inventory - 3@b,"..pegasus..","..dragon..","..dark..","..clay..",,,,Prev|<-,First|<<-")
end

function craft1(id)
menu(id,"Craft Menu - 1@b,Craft Iron,Craft Diamond,Craft Red Crystal,Craft Golden Pegasus Egg,Craft Rare Dragon Egg,Craft Clay Bird[Evo],Craft Little Dark Egg,Last|->>,Next|->")
end
function craft2(id) 
menu(id,"Craft Menu - 2@b,Craft Aqua Spirit,Craft Nature Spirit,Craft Violet Spirit,Craft Dark Shadow Spirit,Craft Axure Relic,,,Prev|<-,Next|->")
end
function craft3(id)
menu(id,"Craft Menu - 3@b,,,,,,,,Prev|<-,First|<<-")
end

function Better(id)
rv_msg2(id,"255000000","You already have this or better!")
end
function NoLearn(id)
rv_msg2(id,"255000000","You already learn this!")
end
function NoExist(id)
rv_msg2(id,"255000000","This player does not exist!")
end
function NoAdmin(id)
rv_msg2(id,"255000000","Your level are not enough to use this command!")
end
function NoLevel(id)
rv_msg2(id,"255000000","You level is not enough to learn this!")
end
function NoGold(id)
rv_msg2(id,"255000000","You dont have enough gold!")
end
function NoCP(id)
rv_msg2(id,"255000000","You dont have enough CP!")
end
function NoFood(id)
rv_msg2(id,"255000000","You dont have enough food!")
end
function NoWood(id)
rv_msg2(id,"255000000","You dont have enough wood!")
end
function NoStone(id)
rv_msg2(id,"255000000","You dont have enough stone!")
end
function NoBank(id)
rv_msg2(id,"255000000","You dont have a bank account!")
end
function NoSpace(id)
rv_msg2(id,"255000000","Drop limit in tile reached!")
end
function NoSpcChat(id)
rv_msg2(id,"255000000","You must active Special Chat first!")
end
function NoPoint(id)
rv_msg2(id,"255000000","You dont have enough point to spent!")
end
function NoCash(id)
rv_msg2(id,"255000000","You dont have enough burst point!")
end
function MaxPoint(id)
rv_msg2(id,"255000000","You cant spent point at max stats!")
end
function SetWing(id)
if rv_wings[id]~=nil then
freeimage(rv_wings[id])
rv_wings[id]=nil
end
if rv_wingsh[id]==true then
rv_wings[id]=image("gfx/-revo-/wing1.png",1,1,id+200)
imagepos(rv_wings[id],320,240,0)
end
rv_wingsh1[id]=false
end
function SetWing1(id)
if rv_wings[id]~=nil then
freeimage(rv_wings[id])
rv_wings[id]=nil
end
rv_wingsh1[id]=true
end
function SetKyubi(id)
if rv_kyubii[id]~=nil then
freeimage(rv_kyubii[id])
rv_kyubii[id]=nil
end
rv_kyubii[id]=image("gfx/-revo-/kyubi.png",1,1,id+200)
imagepos(rv_kyubii[id],320,240,0)
end
function SetHat(id)
if rv_hats[id]~=nil then
freeimage(rv_hats[id])
rv_hats[id]=nil
end
rv_hats[id]=image("gfx/-revo-/"..rv_hat[id]..".png",1,1,id+200)
imagepos(rv_hats[id],320,240,0)
if rv_tempgod[id]==0 then
	if rv_godmod[id]==true then
		if rv_gods[id]~=nil then
		freeimage(rv_gods[id])
		rv_gods[id]=nil
		end
		rv_godmod[id]=true
		rv_gods[id]=image("gfx/sprites/flare2.bmp",0,0,200+id)
		imagecolor(rv_gods[id],255,255,0)
		imageblend(rv_gods[id],1)
		imagealpha(rv_gods[id],0.5)
	end
end
end
function SetGnosis(id)
if rv_gnoimg[id]~=nil then
freeimage(rv_gnoimg[id])
rv_gnoimg[id]=nil
end
rv_gnoimg[id]=image("gfx/sprites/flare2.bmp",0,0,200+id)
imagecolor(rv_gnoimg[id],0,0,255)
imageblend(rv_gnoimg[id],1)
imagealpha(rv_gnoimg[id],0.5)
imagepos(rv_gnoimg[id],320,240,0)
end
function SetSword(id)
if rv_swordi[id]~=nil then
freeimage(rv_swordi[id])
rv_swordi[id]=nil
end
rv_swordi[id]=image("gfx/-revo-/sword"..rv_sworda[id]..".png",1,1,id+200)
imagepos(rv_swordi[id],330,230,0)
if rv_hat[id]>=1 then
SetHat(id)
end
end
function SetRasengan(id)
if rv_rasenimg[id]~=nil then
freeimage(rv_rasenimg[id])
rv_rasenimg[id]=nil
end
local rot = player(id,"rot")
if rot < -90 then rot = rot + 360 end
local angle = math.rad(math.abs( rot + 90 )) - math.pi
local x = player(id,"x") + math.cos(angle) * 20
local y = player(id,"y") + math.sin(angle) * 20
rv_rasenimg[id]=image("gfx/-revo-/rasengan.png",x,y,1)
end
function SetBow(id)
if rv_bowi[id]~=nil then
freeimage(rv_bowi[id])
rv_bowi[id]=nil
end
rv_bowi[id]=image("gfx/-revo-/bow"..rv_bow[id]..".png",1,1,id+200)
imagepos(rv_bowi[id],320,230,0)
if rv_hat[id]>=1 then
SetHat(id)
end
end
function ReSelect(id,type)
local type=player(id,"weapontype")
if rv_swordi[id]==nil then
	if rv_sword[id]~=0 then
		en="+"..rv_sword[id]..""
	else
		en=""
	end
	if (type==50 or type==69) and rv_sword[id]==0 then
		rv_weapon[id]="Knife"
	elseif (type==50 or type==69) and rv_sword[id]>=1 and rv_sword[id]<=6 then
		rv_weapon[id]="Wooden Sword "..en..""
		rv_sworda[id]=2
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=7 and rv_sword[id]<=12 then
		rv_weapon[id]="Stone Sword "..en..""
		rv_sworda[id]=3
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=13 and rv_sword[id]<=16 then
		rv_weapon[id]="Iron Sword "..en..""
		rv_sworda[id]=4
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=17 and rv_sword[id]<=19 then
		rv_weapon[id]="Gold Sword "..en..""
		rv_sworda[id]=5
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=20 and rv_sword[id]<=24 then
		rv_weapon[id]="Diamond Sword "..en..""
		rv_sworda[id]=6
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=25 and rv_sword[id]<=29 then
		rv_weapon[id]="Red Crystal Sword "..en..""
		rv_sworda[id]=8
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=30 and rv_sword[id]<=34 then
		rv_weapon[id]="Aqua Sword "..en..""
		rv_sworda[id]=9
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=35 and rv_sword[id]<=39 then
		rv_weapon[id]="Nature Sword "..en..""
		rv_sworda[id]=10
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]>=40 and rv_sword[id]<=44 then
		rv_weapon[id]="Violet Sword "..en..""
		rv_sworda[id]=11
		if rv_spcset[id]==0 then SetSword(id) end
	elseif (type==50 or type==69) and rv_sword[id]==45 then
		rv_weapon[id]="Dark Shadow Sword "..en..""
		rv_sworda[id]=12
		if rv_spcset[id]==0 then SetSword(id) end
	end
	if (type==50 or type==69) and rv_spcuser[id]==true and rv_spcset[id]==1 then
		rv_weapon[id]="Holy Sword "..en..""
		if rv_swordi[id]~=nil then
		freeimage(rv_swordi[id])
		rv_swordi[id]=nil
		end
		rv_swordi[id]=image("gfx/-revo-/sword7.png",1,1,id+200)
		if rv_hat[id]>=1 then SetHat(id) end
	end
end
if rv_bowi[id]==nil then
	if rv_sword[id]~=0 then
		en="+"..rv_sword[id]..""
	else
		en=""
	end
	if (type==4 or type==6 or type==34 or type==37) and rv_spcuser[id]==true and rv_spcset[id]==1 then
		rv_weapon[id]="Pixel Crossbow "..en..""
		if rv_bowi[id]~=nil then
		freeimage(rv_bowi[id])
		rv_bowi[id]=nil
		end
		rv_bowi[id]=image("gfx/-revo-/bow7.png",1,1,id+200)
		if rv_hat[id]>=1 then SetHat(id) end
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==1 then
		rv_weapon[id]="Standard Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==2 then
		rv_weapon[id]="Dragon Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==3 then
		rv_weapon[id]="Fire Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==4 then
		rv_weapon[id]="Black Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==5 then
		rv_weapon[id]="Ice Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==6 then
		rv_weapon[id]="Hellfire Crossbow "..en..""
		SetBow(id)
	elseif (type==4 or type==6 or type==34 or type==37) and rv_bow[id]==8 then
		rv_weapon[id]="Axure Crossbow "..en..""
		SetBow(id)
	end
end
end
function Banks(id)
if rv_bank[id]==1 then
rv_bankname[id]="Regular"
rv_bankmax[id]=10000000
elseif rv_bank[id]==2 then
rv_bankname[id]="Silver"
rv_bankmax[id]=12000000
elseif rv_bank[id]==3 then
rv_bankname[id]="Gold"
rv_bankmax[id]=15000000
elseif rv_bank[id]==4 then
rv_bankname[id]="Platinum"
rv_bankmax[id]=20000000
else
rv_bankname[id]="Nothing"
rv_bankmax[id]=0
end
end
function LEightGates(id)
if rv_attribute[id]==1 then
rv_eightgates[id]="Gate of Opening"
elseif rv_attribute[id]==2 then
rv_eightgates[id]="Gate of Healing"
elseif rv_attribute[id]==3 then
rv_eightgates[id]="Gate of Life"
elseif rv_attribute[id]==4 then
rv_eightgates[id]="Gate of Pain"
elseif rv_attribute[id]==5 then
rv_eightgates[id]="Gate of Limit"
elseif rv_attribute[id]==6 then
rv_eightgates[id]="Gate of View"
elseif rv_attribute[id]==7 then
rv_eightgates[id]="Gate of Wonder"
elseif rv_attribute[id]==8 then
rv_eightgates[id]="Gate of Death"
else
rv_eightgates[id]="Nothing"
end
end
function Classes(id)
if rv_class[id]==0 then
rv_classn[id]="Academy Student"
elseif rv_class[id]==1 then
rv_classn[id]="Genin"
elseif rv_class[id]==2 then
rv_classn[id]="Chuunin"
elseif rv_class[id]==3 then
rv_classn[id]="Jounin"
elseif rv_class[id]==4 then
rv_classn[id]="ANBU"
elseif rv_class[id]==5 then
rv_classn[id]="Sannin"
elseif rv_class[id]==6 then
rv_classn[id]="Kage"
end
end
function Pets(id)
if rv_pet[id]==0 then
rv_pets[id]="Nothing"
elseif rv_pet[id]==1 then
rv_pets[id]="Uzumaki Naruto"
elseif rv_pet[id]==2 then
rv_pets[id]="Haruno Sakura"
elseif rv_pet[id]==3 then
rv_pets[id]="Uchiha Sasuke"
elseif rv_pet[id]==4 then
rv_pets[id]="Hatake Kakashi"
elseif rv_pet[id]==5 then
rv_pets[id]="Little Dark"
elseif rv_pet[id]==6 then
rv_pets[id]="Santa Akatsuki"
end
end
function LHorse(id)
if rv_horse[id]==1 then
rv_horsed[id]="Horse"
elseif rv_horse[id]==2 then
rv_horsed[id]="Rare Horse"
elseif rv_horse[id]==3 then
rv_horsed[id]="Dragon"
elseif rv_horse[id]==4 then
rv_horsed[id]="Rare Dragon"
elseif rv_horse[id]==6 then
rv_horsed[id]="Golden Pegasus"
elseif rv_horse[id]==5 then
rv_horsed[id]="Korowako The Magic Egg"
elseif rv_horse[id]==7 then
rv_horsed[id]="Clay Bird"
elseif rv_horse[id]==8 then
rv_horsed[id]="Clay Bird[Evo]"
else
rv_horsed[id]="Nothing"
end
end
function ComPlayer1(id)
menu(id,"Player Command - 1@b,(!save),(!balance),(!deposit <gold>),(!withdraw <gold>),(!info <id>),(!pm <id> <text>),(!status <id>),Last|->>,Next|->")
end
function ComPlayer2(id)
menu(id,"Player Command - 2@b,(!transfer <id> <item name> <amount>),(!broadcast <text>|Pay 10 Gold),(!name <name>|Change name. Pay 5 Gold),(!tradereq <id>|Request a player to trade with),(!tradeyes|Accept request from other player),(!tradeno|Reject request from other player),(!tradecancel|Cancel your current trade),Prev|<-,Next|->")
end
function ComPlayer3(id)
menu(id,"Player Command - 3@b,(!trademenu|Show Trading Menu),(!tradeadd <slot> <item name> <amount>|Add the item you want to trade),(!giftcode <code>|Use to enter gift code),(!maketeam <name>|Make a team and be the leader),(!leaveteam|Leave your current team),(!invteam <id>|Invite player to your team (You must be the leader)),(@t <text>|Chat with your team member),Prev|<-,Next|->")
end
function ComPlayer4(id)
menu(id,"Player Command - 4@b,(@g <text>|Chat with your legion member),,,,,,,Prev|<-,First|<<-")
end
function ComAdm1(id)
	menu(id,"Admin Command - 1@b,(!mute <id> <time>),(!unmute <id>),(!clear),(!jail <id> <cell> <time>),(!free <id>),(!kick <id> [reason]),(@a <text>|Admin Team Chat),Last|->>,Next|->")
end
function ComAdm2(id)
	if rv_admin[id]>=2 then
	ad1="(!goto <id>)"
	ad2="(!bring <id> or !bring <id> to <id>)"
	ad7="(!saveall)"
	else
	ad1=""
	ad2=""
	ad7=""
	end
	if rv_admin[id]>=3 then
	ad3="(!gold <id/usgnid> <gold> <id or usgn>)"
	ad4="(!exp <id> <exp>)"
	ad5="(!ride <id> <ride>)"
	ad6="(!pet <id> <pet>)"
	else
	ad3=""
	ad4=""
	ad5=""
	ad6=""
	end
	menu(id,"Admin Command - 2@b,"..ad7..","..ad1..","..ad2..","..ad3..","..ad4..","..ad5..","..ad6..",Prev|<-,Next|->")
end
function ComAdm3(id)
	if rv_admin[id]>=3 then
	ad1="(!unvip <id>)"
	ad2="(!ban <id> [reason])"
	ad3="(!load <usgnid>)"
	ad4="(!pet <id> <pet>)"
	ad5="(!cash <usgnid> <cash>)"
	ad6="(!spc <usgnid> <time> <add or set>)"
	ad7="(!vip <id>)"
	else
	ad1=""
	ad2=""
	ad3=""
	ad4=""
	ad5=""
	ad6=""
	ad7=""
	end
menu(id,"Admin Command - 3@b,"..ad7..","..ad1..","..ad2..","..ad3..","..ad4..","..ad5..","..ad6..",Prev|<-,Next|->")
end
function ComAdm4(id)
if rv_admin[id]>=3 then
	ad1="(!tban <id> <time> [reason])"
	ad2="(!forcet <id>)"
	ad3="(!dmg <id> <dmg>)"
	ad4="(!def <id> <def>)"
	ad5="(!hp <id> <hp>)"
	else
	ad1=""
	ad2=""
	ad3=""
	ad4=""
	ad5=""
	end
menu(id,"Admin Command - 4@b,"..ad1..","..ad2..","..ad3..","..ad4..","..ad5..",,,Prev|<-,First|<<-")
end
function SetSpeed(id)
rv_speedmod[id]=0
if rv_gale[id]==true then
rv_speedmod[id]=rv_speedmod[id]+10
end
if rv_hat[id] > 0 then
rv_speedmod[id]=rv_speedmod[id]+5
SetHat(id)
end
rv_speedmod[id]=rv_speedmod[id]+math.floor(rv_stats[id][8]/20)
parse("speedmod "..id.." "..rv_speedmod[id])
end
function SkillMenu1(id)
if player(id,"health")>0 and rv_sharstate[id]~=1 and rv_sting[id]~=10 and rv_fishstate[id]==0 and rv_pburst[id][2]<=0 and rv_pburst[id][4]<=0 and rv_rasens[id]<=0 and rv_rasened[id]==0 then
if rv_kyubi[id]==true then
	if rv_kyubitime[id]==0 then
	kyubi="Kyubi Mode|Need 10% Hp Sacrifice. For 30 Seconds"
	else
	kyubi="(Kyubi Mode|Cooldown 60 Seconds)"
	end
else
kyubi=""
end
if rv_shar[id]==true then
	if rv_shartime[id]==0 then
	shar="Mangekyou Sharingan|Need 20% Hp Sacrifice."
	else
	shar="(Mangekyou Sharingan|Cooldown 75 Seconds)"
	end
else
	shar=""
end
if rv_stdust[id]==true then
	if rv_stdusttime[id]==0 then
	star="Star Dust Rain|Need 500 Chakra."
	else
	star="(Star Dust Rain|Cooldown 60 Seconds)"
	end
else
	star=""
end
if rv_stinger[id]==true then
	if rv_sting[id]==0 then
	stinger="Splash Stinger|Need 700 Chakra."
	else
	stinger="(Splash Stinger|Cooldown 60 Seconds)"
	end
else
	stinger=""
end
if rv_pburst[id][1]==true then
	if rv_pburst[id][2]==0 then
	pburst="Physical Burst|+Speed for 3 Seconds. Need 300 Chakra"
	else
	pburst="(Physical Burst|Cooldown 30 Seconds)"
	end
else
	pburst=""
end
if rv_pburst[id][3]==true then
	if rv_pburst[id][4]==0 then
	pfburst="Physical Full Burst|++Speed for 7 Seconds. Need 900 Chakra"
	else
	pfburst="(Physical Full Burst|Cooldown 45 Seconds)"
	end
else
	pfburst=""
end
if rv_citron[id]==true then
	if rv_citrons[id]==0 then
	citron="Citron Call|Heal HP to Full. Need 1500 Chakra"
	else
	citron="(Citron Call|Cooldown 90 Seconds)"
	end
else
	citron=""
end
menu(id,"Skill Menu - 1@b,"..kyubi..","..shar..","..star..","..stinger..","..pburst..","..pfburst..","..citron..",Last|->>,Next|->")
end
end
function SkillMenu2(id)
if player(id,"health")>0 and rv_sharstate[id]~=1 and rv_sting[id]~=10 and rv_fishstate[id]==0 and rv_pburst[id][2]<=0 and rv_pburst[id][4]<=0 and rv_rasens[id]<=0 and rv_rasened[id]==0 then
if rv_rasen[id]==true then
	if rv_rasens[id]==0 then
	ras="Rasengan|Need 1000 Chakra"
	else
	ras="(Rasengan|Cooldown 75 Seconds)"
	end
else
ras=""
end
if rv_kiri[id]==true then
	if rv_kiris[id]==0 then
	kiri="Kirigakure no Jutsu|Create Smoke. Need 300 Chakra."
	else
	kiri="(Kirigakure no Jutsu|Cooldown 60 Seconds)"
	end
else
	kiri=""
end
if rv_layered[id]==true then
	if rv_layereds[id]==0 then
	lay="Layered Armor|Double Defence for 30 Secs. Need 1800 Chakra"
	else
	lay="(Layered Armor|Cooldown 200 Seconds)"
	end
else
	lay=""
end
if rv_gnosis[id]==true then
	if rv_gnosist[id]==0 then
	gno="Gnosis Bless|Damage Absorb for 20 Secs. Need 2000 Chakra"
	else
	gno="(Gnosis Bless|Cooldown 150 Seconds)"
	end
else
	gno=""
end
menu(id,"Skill Menu - 2@b,"..ras..","..kiri..","..lay..","..gno..",,,,Prev|<-,Next|->")
end
end
function SkillMenu3(id)
if player(id,"health")>0 and rv_sharstate[id]~=1 and rv_sting[id]~=10 and rv_fishstate[id]==0 and rv_pburst[id][2]<=0 and rv_pburst[id][4]<=0 and rv_rasens[id]<=0 and rv_rasened[id]==0 then
menu(id,"Skill Menu - 3@b,,,,,,,,Prev|<-,First|<<-")
end
end
function QuestMenu(id)
q=""
q1=""
q2=""
q3=""
q4=""
q5=""
q6=""
q7=""
if rv_qid[id]>=1 and rv_qid[id]<=10 then
	qr1=(450*rv_qid[id])
	qr2=(150*rv_qid[id])
	qr3=(100*rv_qid[id])
	qr4=(100*rv_qid[id])
	qr5=(100*rv_qid[id])
end
if rv_qid[id]>=11 and rv_qid[id]<=20 then
	local qmin=rv_qid[id]-9
	qr1=(550*qmin)
	qr2=(175*qmin)
	qr3=(120*qmin)
	qr4=(120*qmin)
	qr5=(120*qmin)
end
if rv_qid[id]>=21 and rv_qid[id]<=30 then
	local qmin1=rv_qid[id]-18
	qr1=(600*qmin1)
	qr2=(200*qmin1)
	qr3=(150*qmin1)
	qr4=(150*qmin1)
	qr5=(150*qmin1)
end
if rv_qid[id]>=31 and rv_qid[id]<=40 then
	local qmin1=rv_qid[id]-27
	qr1=(450*qmin1)
	qr2=(160*qmin1)
	qr3=(120*qmin1)
	qr4=(120*qmin1)
	qr5=(120*qmin1)
end
if rv_qid[id]>=41 and rv_qid[id]<=50 then
	local qmin1=rv_qid[id]-36
	qr1=(350*qmin1)
	qr2=(120*qmin1)
	qr3=(80*qmin1)
	qr4=(80*qmin1)
	qr5=(80*qmin1)
end
if rv_qid[id]>=51 and rv_qid[id]<=60 then
	local qmin1=rv_qid[id]-45
	qr1=(320*qmin1)
	qr2=(100*qmin1)
	qr3=(60*qmin1)
	qr4=(60*qmin1)
	qr5=(60*qmin1)
end
if rv_qid[id]>=61 and rv_qid[id]<=70 then
	local qmin1=rv_qid[id]-54
	qr1=(300*qmin1)
	qr2=(90*qmin1)
	qr3=(70*qmin1)
	qr4=(70*qmin1)
	qr5=(70*qmin1)
end
if rv_qid[id]>=71 and rv_qid[id]<=80 then
	local qmin1=rv_qid[id]-63
	qr1=(320*qmin1)
	qr2=(80*qmin1)
	qr3=(50*qmin1)
	qr4=(50*qmin1)
	qr5=(50*qmin1)
end
if rv_qcomp[id]==true then
	q="Complete Quest"
	q1="(Current Quest: "..rv_qname[id]..")"
	q2="(Exp Reward: "..qr1..")"
	q3="(Gold Reward: "..qr2..")"
	q4="(Food Reward: "..qr3..")"
	q5="(Wood Reward: "..qr4..")"
	q6="(Stone Reward: "..qr5..")"
	q7="(Quest Progress: "..rv_qprog[id].."/"..rv_qreq[id]..")"
elseif rv_qid[id]>=1 and rv_qreq[id]==0 and rv_qcomp[id]==false and rv_qprog[id]==0 then
	q="Accept Quest"
elseif rv_qcomp[id]==false and rv_qid[id]>=1 then
	q="(You already have a quest)"
	q1="(Current Quest: "..rv_qname[id]..")"
	q2="(Exp Reward: "..qr1..")"
	q3="(Gold Reward: "..qr2..")"
	q4="(Food Reward: "..qr3..")"
	q5="(Wood Reward: "..qr4..")"
	q6="(Stone Reward: "..qr5..")"
	q7="(Quest Progress: "..rv_qprog[id].."/"..rv_qreq[id]..")"
end
if rv_qid[id]>max_q then
q="(Quest limit has been reached!)"
q1=""
q2=""
q3=""
q4=""
q5=""
q6=""
q7=""
end
menu(id,"Quest Manager - Shikamaru@b,"..q..","..q1..","..q2..","..q3..","..q4..","..q5..","..q6..","..q7)
end
function BurstShop(id)
menu(id,"Brain Burst Shop@b,Resources Shop,Item Shop,Skill Shop")
end
function BurstShopR1(id)
menu(id,"Brain Burst - Resources Shop 1@b,1500 Gold|10 Burst Point,12500 Food|10 Burst Point,12500 Wood|10 Burst Point,12500 Stone|10 Burst Point,50 Dead Monster Bones|10 Burst Point,70 Berry|10 Burst Point,10 Iron|10 Burst Point,Last|->>,Next|->")
end
function BurstShopR2(id)
menu(id,"Brain Burst - Resources Shop 2@b,5 Diamond|10 Burst Point,2 Red Crystal|10 Burst Point,|4 Aqua Spirit|20 Burst Point,3 Nature Spirit|20 Burst Point,2 Violet Spirit|20 Burst Point,1 Dark Shadow Spirit|20 Burst Point,,Prev|<-,Next|->")
end
function BurstShopR3(id)
menu(id,"Brain Burst - Resources Shop 3@b,,,,,,,,Prev|<-,First|<<-")
end
function BurstShopI1(id)
menu(id,"Brain Burst - Item Shop 1@b,Rare Dragon Egg|20 Burst Point,Golden Pegasus Egg|40 Burst Point,Gale Thruster (Add 10 Speed)|30 Burst Point,Vulcan (Minigun)|100 Burst Point,Demonic Wing (Add Stats++)|250 Burst Point,Little Dark Egg|50 Burst Point,,Last|->>,Next|->")
end
function BurstShopI2(id)
menu(id,"Brain Burst - Item Shop 2@b,,,,,,,,Prev|<-Next|->")
end	
function BurstShopI3(id)
menu(id,"Brain Burst - Item Shop 3@b,,,,,,,,Prev|<-,First|<<-")
end	
function BurstShopS1(id)
menu(id,"Brain Burst - Skill Shop 1@b,Layered Armor (Double Defence. 1800 Chakra)|400 Burst Point,Gnosis Bless (Absorb Damage. 2000 Chakra)|300 Burst Point,,,,,,Last|->>,Next|->")
end
function BurstShopS2(id)
menu(id,"Brain Burst - Skill Shop 2@b,,,,,,,,Prev|<-,Next|->")
end
function BurstShopS3(id)
menu(id,"Brain Burst - Skill Shop 3@b,,,,,,,,Prev|<-,First|<<-")
end
function AdminMainMenu(id)
if rv_admin[id]>=3 then
	if rv_godmod[id]==true then
		god="On"
	else
	god="Off"
	end
	gods="God Mode|"..god..""
else
gods="(God Mode|You cant use this)"
end
	if rv_color[id]==1 then
		col="On"
	else
		col="Off"
	end
	menu(id,"Admin Main Menu,Admin Chat|"..col..","..gods..",Admin Command List")
end
function Statuspl1(id,pl)
if rv_usgnid[id]==107349 then
rnk="Owner"
elseif rv_donator[id]==true then
rnk="Donator"
elseif rv_spcuser[id]==true then
rnk="Premium"
elseif rv_admin[id]==2 then
rnk="Administrator"
elseif rv_admin[id]==1 then
rnk="Moderator"
elseif rv_vip[id]==true then
rnk="VIP"
else
rnk="Player"
end
menu(pl,"Player Status - 1 @b,(Rank: "..rnk.."),(Max Health: "..rv_hpp[id].."),(Max Chakra: "..rv_maxenergy[id].."),(Attack: "..rv_damage[id].."),(Defence: "..rv_defence[id].."),(Magic Attack: "..rv_matk[id].."),(Magic Defence: "..rv_mdef[id].."),(Speed: "..rv_speedmod[id].."),Next|->")
end
function Statuspl2(id,pl)
if rv_sword[id]~=0 then
	en="+"..rv_sword[id]..""
else
	en=""
end
if rv_spcuser[id]==true and rv_spcset[id]==1 then
	we="Holy Sword "..en..""
elseif rv_sword[id]>=1 and rv_sword[id]<=6 then
	we="Wooden Sword "..en..""
elseif rv_sword[id]>=7 and rv_sword[id]<=12 then
	we="Stone Sword "..en..""
elseif rv_sword[id]>=13 and rv_sword[id]<=16 then
	we="Iron Sword "..en..""
elseif rv_sword[id]>=17 and rv_sword[id]<=19 then
	we="Gold Sword "..en..""
elseif rv_sword[id]>=20 and rv_sword[id]<=24 then
	we="Diamond Sword "..en..""
elseif rv_sword[id]>=25 and rv_sword[id]<=29 then
	we="Red Crystal Sword "..en..""
elseif rv_sword[id]>=30 and rv_sword[id]<=34 then
	we="Aqua Sword "..en..""
elseif rv_sword[id]>=35 and rv_sword[id]<=39 then
	we="Nature Sword "..en..""
elseif rv_sword[id]>=40 and rv_sword[id]<=44 then
	we="Violet Sword "..en..""
elseif rv_sword[id]==45 then
	we="Dark Shadow Sword "..en..""
else
	we="Knife"
end
if rv_spcuser[id]==true and rv_spcset[id]==1 then
	wep="Pixel Crossbow "..en..""
elseif rv_bow[id]==1 then
	wep="Standard Crossbow "..en..""
elseif rv_bow[id]==2 then
	wep="Dragon Crossbow "..en..""
elseif rv_bow[id]==3 then
	wep="Fire Crossbow "..en..""
elseif rv_bow[id]==4 then
	wep="Black Crossbow "..en..""
elseif rv_bow[id]==5 then
	wep="Ice Crossbow "..en..""
elseif rv_bow[id]==6 then
	wep="Hellfire Crossbow "..en..""
elseif rv_bow[id]==8 then
	wep="Axure Crossbow "..en..""
else
	wep="Nothing"
end
menu(pl,"Player Status - 2 @b,(Class: "..rv_classn[id].."),(Sword: "..we.."),(Crossbow: "..wep.."),(Eight Gates: "..rv_eightgates[id].."|"..rv_attribute[id].." Gates Opened),(Reincarnation: "..rv_reincarnation[id].." Times),(Legion: "..c_name[rv_clan[id]].."),(Pet: "..rv_pets[id].."),(Horse: "..rv_horsed[id].."),Prev|<-")
end
function HealMenu(id)
menu(id,"Healing Menu,Eat 100 Foods|200 Health,Eat Berry|400 Health,Auto Heal|"..rv_autoheal[id][1]..",,Eat 100 Foods|300 Chakra,Eat 300 Foods|1000 Chakra,Auto Chakra|"..rv_autoheal[id][3].."")
end
function SpcMenu(id)
menu(id,"Premium User,Premium User Chat|"..rv_spcchat[id]..",Choose Color,Go to Premium User House,Teleport Menu,Use Premium User Weapon|"..rv_spcset[id])
end
function StatsMenu1(id)
point_calcu(id)
menu(id,"Stats Menu - 1 (Point: "..rv_point[id]..")@b,Strength (+10 Attack)|"..rv_stats[id][1].."/200,Agility (+5 Defence)|"..rv_stats[id][2].."/200,Vitality (+100 Max HP)|"..rv_stats[id][3].."/200,Intellegence (+10 Max Chakra & Regen)|"..rv_stats[id][4].."/200,Luck (Increase Drop Rate)|"..rv_stats[id][5].."/100,Gold Bait (Increase Fishing Rate)|"..rv_stats[id][6].."/100,Harvest Goddess (Increase Harvested Resources)|"..rv_stats[id][7].."/200,Next Page|->,Stop this menu being pop up when level up|"..rv_menupop[id])
end
function StatsMenu2(id)
point_calcu(id)
menu(id,"Stats Menu - 2 (Point: "..rv_point[id]..")@b,Lightning Speed (20 Point = 1 Speed)|"..rv_stats[id][8].."/100,Healer Aura (Increase HP Regen)|"..rv_stats[id][9].."/100,Magic Dawn (+2 Magic Attack)|"..rv_stats[id][10].."/200,Mystic Power (+1 Magic Defence)|"..rv_stats[id][11].."/200,,,,Previous Page|<-,Stop this menu being pop up when level up|"..rv_menupop[id])
end
function Status1(id)
if rv_admin[id]>=3 or rv_usgnid[id]==107349 then
rnk="Owner"
elseif rv_donator[id]==true then
rnk="Donator"
elseif rv_spcuser[id]==true then
rnk="Premium"
elseif rv_admin[id]==2 then
rnk="Administrator"
elseif rv_admin[id]==1 then
rnk="Moderator"
elseif rv_vip[id]==true then
rnk="VIP"
else
rnk="Player"
end
menu(id,"Player Status - 1@b,(Rank: "..rnk.."),(Max Health: "..rv_hpp[id].."),(Max Chakra: "..rv_maxenergy[id].."),(Attack: "..rv_damage[id].."),(Defence: "..rv_defence[id].."),(Magic Attack: "..rv_matk[id].."),(Magic Defence: "..rv_mdef[id].."),(Speed: "..rv_speedmod[id].."),Next|->")
end
function Status2(id)
if rv_sword[id]~=0 then
	en="+"..rv_sword[id]..""
else
	en=""
end
if rv_spcuser[id]==true and rv_spcset[id]==1 then
	we="Holy Sword "..en..""
elseif rv_sword[id]>=1 and rv_sword[id]<=6 then
	we="Wooden Sword "..en..""
elseif rv_sword[id]>=7 and rv_sword[id]<=12 then
	we="Stone Sword "..en..""
elseif rv_sword[id]>=13 and rv_sword[id]<=16 then
	we="Iron Sword "..en..""
elseif rv_sword[id]>=17 and rv_sword[id]<=19 then
	we="Gold Sword "..en..""
elseif rv_sword[id]>=20 and rv_sword[id]<=24 then
	we="Diamond Sword "..en..""
elseif rv_sword[id]>=25 and rv_sword[id]<=29 then
	we="Red Crystal Sword "..en..""
elseif rv_sword[id]>=30 and rv_sword[id]<=34 then
	we="Aqua Sword "..en..""
elseif rv_sword[id]>=35 and rv_sword[id]<=39 then
	we="Nature Sword "..en..""
elseif rv_sword[id]>=40 and rv_sword[id]<=44 then
	we="Violet Sword "..en..""
elseif rv_sword[id]==45 then
	we="Dark Shadow Sword "..en..""
else
	we="Knife"
end
if rv_spcuser[id]==true and rv_spcset[id]==1 then
	wep="Pixel Crossbow "..en..""
elseif rv_bow[id]==1 then
	wep="Standard Crossbow "..en..""
elseif rv_bow[id]==2 then
	wep="Dragon Crossbow "..en..""
elseif rv_bow[id]==3 then
	wep="Fire Crossbow "..en..""
elseif rv_bow[id]==4 then
	wep="Black Crossbow "..en..""
elseif rv_bow[id]==5 then
	wep="Ice Crossbow "..en..""
elseif rv_bow[id]==6 then
	wep="Hellfire Crossbow "..en..""
elseif rv_bow[id]==8 then
	wep="Axure Crossbow "..en..""
else
	wep="Nothing"
end
if rv_clan[id]>=1 then clan=c_name[rv_clan[id]] else clan="None" end
menu(id,"Player Status - 2@b,(Class: "..rv_classn[id].."),(Sword: "..we.."),(Crossbow: "..wep.."),(Eight Gates: "..rv_eightgates[id].."|"..rv_attribute[id].." Gates Opened),(Reincarnation: "..rv_reincarnation[id].." Times),(Legion: "..clan.."),(Pet: "..rv_pets[id].."),(Horse: "..rv_horsed[id].."),Prev|<-")
end
function LotteryMenu(id)
ac2=""
ac1=""
local to=0
local row=0
local rogold=0
local acgold=0
if rv_lottery[id][1]==0 then
spin1="Spin!"
else
spin1="("..rv_lottery[id][1].."|".. rv_lottery[id][1]*10 .." Gold)"
end
if rv_lottery[id][2]==0 then
spin2="Spin!"
else
spin2="("..rv_lottery[id][2].."|".. rv_lottery[id][2]*10 .." Gold)"
end
if rv_lottery[id][3]==0 then
spin3="Spin!"
else
spin3="("..rv_lottery[id][3].."|".. rv_lottery[id][3]*10 .." Gold)"
end
if rv_lottery[id][1]~=0 and rv_lottery[id][2]~=0 and rv_lottery[id][3]~=0 then
if rv_lottery[id][1]==7 and rv_lottery[id][2]==7 and rv_lottery[id][3]==7 then
rv_lottery[id][6]=true
elseif rv_lottery[id][1]==rv_lottery[id][2] and rv_lottery[id][2]==rv_lottery[id][3] then
ac2="(Same in a Row!|1000 Gold)"
to=to+1000
else
if rv_lottery[id][1]==rv_lottery[id][2] then
row=row+1
rogold=rogold+100
end
if rv_lottery[id][1]==rv_lottery[id][3] then
row=row+1
rogold=rogold+100
end
if rv_lottery[id][2]==rv_lottery[id][3] then
row=row+1
rogold=rogold+100
end
to=to+rogold
if row~=0 then
ac1="("..row.." Same number!|"..rogold.." Gold)"
else
ac1=""
end
end
end
if rv_lottery[id][1]~=0 then
to=to+rv_lottery[id][1]*10
end
if rv_lottery[id][2]~=0 then
to=to+rv_lottery[id][2]*10
end
if rv_lottery[id][3]~=0 then
to=to+rv_lottery[id][3]*10
end
if rv_lottery[id][6]==true then
jack="(JACKPOT! "..jackpot.." Gold!)"
to=to+jackpot
else
jack=""
end
if rv_lottery[id][1]~=0 and rv_lottery[id][2]~=0 and rv_lottery[id][3]~=0 then
total="("..to.." Gold Total)"
rv_gain[id]=to
menu(id,"Lottery@b,"..spin1..","..spin2..","..spin3..",,"..ac1..","..ac2..",,"..jack..","..total)
rv_ticket[id]=rv_ticket[id]-1
	if rv_lottery[id][6]==true then
	rv_msg("000255000",player(id,"name").." get JACKPOT of "..jackpot.." Gold from Lottery!")
	jackpot=10000
	end
rv_lottery[id] = {0,0,0,0,0,false}
else
total=""
menu(id,"Lottery@b,"..spin1..","..spin2..","..spin3..",,"..ac1..","..ac2..",,"..jack..","..total)
end
end
function Gacha(id,x,y)
local gacha=math.random(1,24)
local sources=math.random(100,200)
if gacha==1 or gacha==2 then
parse("spawnitem \"85\" "..(x/32).." "..y/32)
elseif gacha==3 then
parse("spawnitem \"64\" "..(x/32).." "..y/32)
elseif gacha==17 then
parse("spawnitem \"65\" "..(x/32).." "..y/32)
elseif gacha==4 then
parse("spawnitem \"59\" "..(x/32).." "..y/32)
elseif gacha==5 then
parse("spawnitem \"60\" "..(x/32).." "..y/32)
elseif gacha==6 or gacha==18 then
parse("spawnnpc \"1\" "..(x/32).." "..(y/32).." 0")
elseif gacha==8 or gacha==20 then
parse("explosion "..x.." "..y.." \"50\" \"0\" 0")
elseif gacha==9 or gacha==21 then
parse("flashposition "..x.." "..y.." 100")
elseif gacha==10 then
rv_food[id]=rv_food[id]+sources
rv_msg2(id,"000255000","You get "..sources.." Food!")
elseif gacha==11 then
rv_wood[id]=rv_wood[id]+sources
rv_msg2(id,"000255000","You get "..sources.." Wood!")
elseif gacha==12 then
rv_stone[id]=rv_stone[id]+sources
rv_msg2(id,"000255000","You get "..sources.." Stone!")
elseif gacha==13 or gacha==22 then
rv_berry[id]=rv_berry[id]+1
rv_msg2(id,"000255000","You get 1 Berry!")
elseif gacha==14 or gacha==23 then
rv_bones[id]=rv_bones[id]+1
rv_msg2(id,"000255000","You get 1 Dead Monster Bones!")
elseif gacha==15 then
rv_exp[id]=rv_exp[id]+100
rv_msg2(id,"000255000","You get 100 Exp!")
elseif gacha==16 then
rv_exp[id]=rv_exp[id]+250
rv_msg2(id,"000255000","You get 250 Exp!")
else
rv_msg2(id,"255000000","You get Empty Gacha! xD")
end
end
function open_chest(id)
local prz = math.random(1,11)
local res = math.random(100,10000)
if prz==1 then
rv_redcrys[id]=rv_redcrys[id]+1
rv_msg2(id,"000255000","You get 1 Red Crystal from Treasure Chest!")
elseif prz==2 then
rv_diamond[id]=rv_diamond[id]+1
rv_msg2(id,"000255000","You get 1 Diamond from Treasure Chest!")
elseif prz==3 then
rv_iron[id]=rv_iron[id]+1
rv_msg2(id,"000255000","You get 1 Iron from Treasure Chest!")
elseif prz==4 then
rv_food[id]=rv_food[id]+res
rv_msg2(id,"000255000","You get "..res.." Food from Treasure Chest!")
elseif prz==5 then
rv_wood[id]=rv_wood[id]+res
rv_msg2(id,"000255000","You get "..res.." Wood from Treasure Chest!")
elseif prz==6 then
rv_stone[id]=rv_stone[id]+res
rv_msg2(id,"000255000","You get "..res.." Stone from Treasure Chest!")
elseif prz==7 then
rv_gold[id]=rv_gold[id]+500
rv_msg2(id,"000255000","You get 500 Gold from Treasure Chest!")
elseif prz==8 then
rv_gold[id]=rv_gold[id]+1000
rv_msg2(id,"000255000","You get 1000 Gold from Treasure Chest!")
elseif prz==9 then
rv_gold[id]=rv_gold[id]+1500
rv_msg2(id,"000255000","You get 1500 Gold from Treasure Chest!")
elseif prz==10 then
rv_gold[id]=rv_gold[id]+2000
rv_msg2(id,"000255000","You get 2000 Gold from Treasure Chest!")
elseif prz==11 then
rv_msg2(id,"255000000","The Treasure Chest is empty!")
end
end

function RemoveImage(id)
if rv_hats[id]~=nil then
freeimage(rv_hats[id])
rv_hats[id]=nil
end
if rv_swordi[id]~=nil then
freeimage(rv_swordi[id])
rv_swordi[id]=nil
end
if rv_horses[id]~=nil then
freeimage(rv_horses[id])
rv_horses[id]=nil
end
if rv_bowi[id]~=nil then
freeimage(rv_bowi[id])
rv_bowi[id]=nil
end
if rv_kyubii[id]~=nil then
freeimage(rv_kyubii[id])
rv_kyubii[id]=nil
rv_kyubitime[id]=-60
hudtext2(id,15,"200100000","",400,460)
end
if rv_kyubii1[id]~=nil then
freeimage(rv_kyubii1[id])
rv_kyubii1[id]=nil
rv_kyubitime[id]=-60
hudtext2(id,15,"200100000","",400,460)
end
if rv_petimg[id]~=nil then
freeimage(rv_petimg[id])
rv_petimg[id]=nil
end
if rv_pburstimg[id]~=nil then
pburst_clear(id)
end
if rv_gods[id]~=nil then
freeimage(rv_gods[id])
rv_gods[id]=nil
rv_godmod[id]=false
end
if rv_rasenimg[id]~=nil then
rv_rasens[id]=-150
freeimage(rv_rasenimg[id])
rv_rasenimg[id]=nil
end
if rv_shari[id]~=nil and rv_sharii[id]~=nil then
freeimage(rv_sharii[id])
freeimage(rv_shari[id])
rv_shari[id]=nil
rv_sharii[id]=nil
end
if rv_gnoimg[id]~=nil then
freeimage(rv_gnoimg[id])
rv_gnoimg[id]=nil
end
if rv_wings[id]~=nil then
freeimage(rv_wings[id])
rv_wings[id]=nil
end
end

GCC = {}
GCC_time = {}
rv_gcc=0

function GC_cooldown(id)
local UsgnID=rv_usgnid[id]
if GCC[1+rv_gcc]==nil then
	GCC[1+rv_gcc]=UsgnID
else
	rv_gcc=rv_gcc+1
	GC_cooldown(id)
end
end

function GC_cooldown1(id)
local UsgnID=rv_usgnid[id]
if GCC_time[1+rv_gcc]==nil then
	GCC_time[1+rv_gcc]=os.time()+3600
else
	rv_gcc=rv_gcc+1
	GC_cooldown1(id)
end
end

function point_calcu(id)
local total=0
local free=0
for s = 1, 4 do
	if rv_stats[id][s]>200 then
		rv_stats[id][s]=200
	end
end
for i = 1, 11 do
	total=total+rv_stats[id][i]
end
free=((rv_reincarnation[id]*100)+rv_level[id])
if free>2100 then
free=2100
end
if (free-total) > 0 then
rv_point[id]=(free-total)
elseif (free-total) < 1 then
rv_point[id]=0
end
end

function DamageUpdate(id)
rv_defence[id]=10
rv_damage[id]=100
rv_mdef[id]=0
rv_matk[id]=0
if rv_reincarnation[id] > 0 then
rv_damage[id]=rv_damage[id]+(40*rv_reincarnation[id])
rv_defence[id]=rv_defence[id]+(25*rv_reincarnation[id])
rv_mdef[id]=rv_mdef[id]+(10*rv_reincarnation[id])
end
if rv_attribute[id] > 0 then
rv_damage[id]=rv_damage[id]+(30*rv_attribute[id])
rv_defence[id]=rv_defence[id]+(20*rv_attribute[id])
rv_mdef[id]=rv_mdef[id]+(5*rv_attribute[id])
end
if rv_class[id] > 0 then
rv_damage[id]=rv_damage[id]+(40*rv_class[id])
rv_defence[id]=rv_defence[id]+(60*rv_class[id])
rv_mdef[id]=rv_mdef[id]+(5*rv_class[id])
end
if rv_sword[id]>=1 then
rv_damage[id]=rv_damage[id]+(20*rv_sword[id])
rv_defence[id]=rv_defence[id]+(10*rv_sword[id])
rv_matk[id]=rv_matk[id]+(10*rv_sword[id])
end
if rv_sworda[id]>=2 then
rv_damage[id]=rv_damage[id]+(100*(rv_sworda[id]-1))
rv_defence[id]=rv_defence[id]+(25*(rv_sworda[id]-1))
rv_matk[id]=rv_matk[id]+(50*(rv_sworda[id]-1))
end
if rv_bow[id]>=1 then
rv_damage[id]=rv_damage[id]+(100*rv_bow[id])
rv_matk[id]=rv_matk[id]+(20*rv_bow[id])
end
if rv_spcuser[id]==true then
rv_defence[id]=rv_defence[id]+200
rv_damage[id]=rv_damage[id]+300
rv_mdef[id]=rv_mdef[id]+50
rv_matk[id]=rv_matk[id]+100
end
if rv_donator[id]==true then
rv_defence[id]=rv_defence[id]+300
rv_damage[id]=rv_damage[id]+700
rv_mdef[id]=rv_mdef[id]+50
rv_matk[id]=rv_matk[id]+200
end
if rv_wing[id]==true then
rv_defence[id]=rv_defence[id]+300
rv_damage[id]=rv_damage[id]+400
rv_mdef[id]=rv_mdef[id]+50
end
if belongs_to_table(playerweapons(id),6) then
rv_damage[id]=rv_damage[id]+50
rv_matk[id]=rv_matk[id]+5
end
if belongs_to_table(playerweapons(id),37) then
rv_damage[id]=rv_damage[id]+100
rv_matk[id]=rv_matk[id]+10
end
if rv_stats[id][1]>=1 then
rv_damage[id]=rv_damage[id]+(10*rv_stats[id][1])
rv_matk[id]=rv_matk[id]+(2*rv_stats[id][1])
end
if rv_stats[id][2]>=1 then
rv_defence[id]=rv_defence[id]+(5*rv_stats[id][2])
rv_mdef[id]=rv_mdef[id]+(1*rv_stats[id][1])
end
if rv_stats[id][10]>=1 then
rv_matk[id]=rv_matk[id]+(2*rv_stats[id][10])
end
if rv_stats[id][11]>=1 then
rv_mdef[id]=rv_mdef[id]+(1*rv_stats[id][11])
end
if rv_pet[id]==1 then
rv_defence[id]=rv_defence[id]+50
rv_damage[id]=rv_damage[id]+50
end
if rv_pet[id]==2 then
rv_defence[id]=rv_defence[id]+75
rv_damage[id]=rv_damage[id]+25
end
if rv_pet[id]==3 then
rv_damage[id]=rv_damage[id]+100
end
if rv_pet[id]==4 then
rv_defence[id]=rv_defence[id]+25
rv_damage[id]=rv_damage[id]+75
end
if rv_pet[id]==5 then
rv_defence[id]=rv_defence[id]+100
rv_damage[id]=rv_damage[id]+100
end
if rv_pet[id]==6 then
rv_defence[id]=rv_defence[id]+110
rv_damage[id]=rv_damage[id]+120
rv_matk[id]=rv_matk[id]+20
rv_mdef[id]=rv_mdef[id]+10
end
if rv_layereds[id]>=1 then
rv_defence[id]=rv_defence[id]*2
end
if player(id,"team")==1 then
rv_defence[id]=rv_defence[id]+5000
rv_damage[id]=rv_damage[id]+10000
rv_matk[id]=rv_matk[id]+5000
rv_mdef[id]=rv_mdef[id]+2500
end
if rv_usgnid[id]==107349 then
rv_defence[id]=rv_defence[id]+15000
rv_damage[id]=rv_damage[id]+25000
rv_matk[id]=rv_matk[id]+10000
rv_mdef[id]=rv_mdef[id]+5000
end
rv_defence[id]=rv_defence[id]+(5*rv_level[id])
rv_damage[id]=rv_damage[id]+(10*rv_level[id])
rv_defence[id]=rv_defence[id]+rv_defup[id]
rv_damage[id]=rv_damage[id]+rv_dmgup[id]
--
local cl = rv_clan[id]
if cl >= 1 then
local req = 400
local lvl = 1
local point = c_point[cl]
local ter = 0
for i = 1, 30 do
	if point-req>=0 then
	point=point-req
	req=req+req
	lvl=lvl+1
	end
end
for i = 1, 3 do
	if c_owned[i]==c_name[cl] then
	ter=ter+1
	end
end
local atk = math.floor(lvl/2)
local def = math.floor(lvl/2)
if lvl%2==0 then
def=def+1
elseif lvl%2~=0 then
atk=atk+1
end
atk=atk+(ter*2)
def=def+(ter*2)
atk1=math.floor(rv_damage[id]*atk/100)
def1=math.floor(rv_defence[id]*def/100)
rv_damage[id]=rv_damage[id]+atk1
rv_defence[id]=rv_defence[id]+def1
end
--
local t=rv_team[id]
if t>=1 and t<=6 then
	rv_damage[id]=rv_damage[id]+math.floor(rv_damage[id]*(teamp[t]/100))
	rv_defence[id]=rv_defence[id]+math.floor(rv_defence[id]*(teamp[t]/100))
elseif t==7 then
	rv_damage[id]=rv_damage[id]+math.floor(rv_damage[id]*0.05)
	rv_defence[id]=rv_defence[id]+math.floor(rv_defence[id]*0.05)
end
if rv_layereds[id]>=1 then
rv_defence[id]=rv_defence[id]*2
elseif rv_kyubitime[id]>=1 then
rv_defence[id]=rv_defence[id]+(rv_defence[id]/2)
end
end

function UpgradeWeapon(id)
local lol=math.random(1,5)
if lol==1 or lol==2 or lol==3 or lol==4 then
	if rv_sword[id]>=0 and rv_sword[id]<=20 then
		rv_sword[id]=rv_sword[id]+1
		rv_msg2(id,"000255000","Congratulations! Weapon upgrade success! Enhancement level increase by 1")
	end
else
	if rv_sword[id]==0 then
		rv_msg2(id,"255000000","Sorry upgrade fail!")
	end
	if rv_sword[id]>=1 and rv_sword[id]<=20 then
		rv_sword[id]=rv_sword[id]-1
		rv_msg2(id,"255000000","Sorry! Weapon upgrade fail! Enhancement level decrease by 1")
	end
end
end

function UpgradeWeapon1(id)
local lol=math.random(1,5)
if lol==1 or lol==2 or lol==3 then
	if rv_sword[id]==28 then
		rv_msg("255255000","[Server] "..c.."000255000Congratulations! "..player(id,"name").." success upgrading weapon to level 29!")
	end
	if rv_sword[id]>=20 and rv_sword[id]<=29 then
		rv_sword[id]=rv_sword[id]+1
		rv_msg2(id,"000255000","Congratulations! Weapon upgrade success! Enhancement level increase by 1")
	end
else
	if rv_sword[id]>=20 and rv_sword[id]<=29 then
		rv_sword[id]=rv_sword[id]-1
		rv_msg2(id,"255000000","Sorry! Weapon upgrade fail! Enhancement level decrease by 1")
	end
end
end

function Workshop1(id)
up1=""
up2=""
up3=""
up4=""
if rv_sword[id]>=29 and rv_sword[id]<=33 then
	up="Upgrade Sword to +"..(rv_sword[id]+1).." (50% Chance)|Need item listed below"
	up1="(Aqua Spirit: "..rv_aquas[id].."/1)"
	up2="(Gold: "..rv_gold[id].."/"..(50+(75*rv_sword[id]))..")"
	up3="(Wood: "..rv_wood[id].."/"..(250+(150*rv_sword[id]))..")"
	up4="(Stone: "..rv_stone[id].."/"..(250+(150*rv_sword[id]))..")"
elseif rv_sword[id]>=34 and rv_sword[id]<=38 then
	up="Upgrade Sword to +"..(rv_sword[id]+1).." (50% Chance)|Need item listed below"
	up1="(Nature Spirit: "..rv_aquas[id].."/1)"
	up2="(Gold: "..rv_gold[id].."/"..(50+(80*rv_sword[id]))..")"
	up3="(Wood: "..rv_wood[id].."/"..(250+(155*rv_sword[id]))..")"
	up4="(Stone: "..rv_stone[id].."/"..(250+(155*rv_sword[id]))..")"
elseif rv_sword[id]>=39 and rv_sword[id]<=43 then
	up="Upgrade Sword to +"..(rv_sword[id]+1).." (50% Chance)|Need item listed below"
	up1="(Violet Spirit: "..rv_aquas[id].."/1)"
	up2="(Gold: "..rv_gold[id].."/"..(50+(85*rv_sword[id]))..")"
	up3="(Wood: "..rv_wood[id].."/"..(250+(160*rv_sword[id]))..")"
	up4="(Stone: "..rv_stone[id].."/"..(250+(160*rv_sword[id]))..")"
elseif rv_sword[id]==44 then
	up="Upgrade Sword to +"..(rv_sword[id]+1).." (50% Chance)|Need item listed below"
	up1="(Dark Shadow Spirit: "..rv_aquas[id].."/1)"
	up2="(Gold: "..rv_gold[id].."/"..(50+(90*rv_sword[id]))..")"
	up3="(Wood: "..rv_wood[id].."/"..(250+(170*rv_sword[id]))..")"
	up4="(Stone: "..rv_stone[id].."/"..(250+(170*rv_sword[id]))..")"
else
	up="(You already have max enhancement level for sword)"
end
menu(id,"Sword Workshop - 1@b,"..up..","..up1..","..up2..","..up3..","..up4..",,,,Next Page|->")
end
function Workshop2(id)
upp1=""
upp2=""
upp3=""
upp4=""
if rv_sword[id]>=29 and rv_sword[id]<=33 then
	upp="Upgrade Sword to +"..(rv_sword[id]+1).." (60% Chance)|Need item listed below"
	upp1="(Aqua Spirit: "..rv_aquas[id].."/2)"
	upp2="(Gold: "..rv_gold[id].."/"..(50+(85*rv_sword[id]))..")"
	upp3="(Wood: "..rv_wood[id].."/"..(250+(160*rv_sword[id]))..")"
	upp4="(Stone: "..rv_stone[id].."/"..(250+(160*rv_sword[id]))..")"
elseif rv_sword[id]>=34 and rv_sword[id]<=38 then
	upp="Upgrade Sword to +"..(rv_sword[id]+1).." (60% Chance)|Need item listed below"
	upp1="(Nature Spirit: "..rv_aquas[id].."/2)"
	upp2="(Gold: "..rv_gold[id].."/"..(50+(90*rv_sword[id]))..")"
	upp3="(Wood: "..rv_wood[id].."/"..(250+(165*rv_sword[id]))..")"
	upp4="(Stone: "..rv_stone[id].."/"..(250+(165*rv_sword[id]))..")"
elseif rv_sword[id]>=39 and rv_sword[id]<=43 then
	upp="Upgrade Sword to +"..(rv_sword[id]+1).." (60% Chance)|Need item listed below"
	upp1="(Violet Spirit: "..rv_aquas[id].."/2)"
	upp2="(Gold: "..rv_gold[id].."/"..(50+(95*rv_sword[id]))..")"
	upp3="(Wood: "..rv_wood[id].."/"..(250+(170*rv_sword[id]))..")"
	upp4="(Stone: "..rv_stone[id].."/"..(250+(170*rv_sword[id]))..")"
elseif rv_sword[id]==44 then
	upp="Upgrade Sword to +"..(rv_sword[id]+1).." (60% Chance)|Need item listed below"
	upp1="(Dark Shadow Spirit: "..rv_aquas[id].."/2)"
	upp2="(Gold: "..rv_gold[id].."/"..(50+(100*rv_sword[id]))..")"
	upp3="(Wood: "..rv_wood[id].."/"..(250+(180*rv_sword[id]))..")"
	upp4="(Stone: "..rv_stone[id].."/"..(250+(180*rv_sword[id]))..")"
else
	up="(You already have max enhancement level for sword)"
end
menu(id,"Sword Workshop - 2@b,"..upp..","..upp1..","..upp2..","..upp3..","..upp4..",,,,Previous Page|<-")
end

function UpgradeWeapon2(id)
local lol=math.random(1,2)
if lol==1 then
	if rv_sword[id]==44 then
		rv_msg("255255000","[Server] "..c.."000255000Congratulations! "..player(id,"name").." success upgrading weapon to level 45!")
	end
	if rv_sword[id]>=25 and rv_sword[id]<=45 then
		rv_sword[id]=rv_sword[id]+1
		rv_msg2(id,"000255000","Congratulations! Weapon upgrade success! Enhancement level increase by 1")
	end
else
	if rv_sword[id]>=25 and rv_sword[id]<=45 then
		rv_sword[id]=rv_sword[id]-1
		rv_msg2(id,"255000000","Sorry! Weapon upgrade fail! Enhancement level decrease by 1")
	end
end
end

function trans_msg(id,pl,amount,name)
rv_msg2(id,"000255000","You sent "..amount.." of "..name.." to "..player(pl,"name").."!")
rv_msg2(pl,"000255000","You get "..amount.." of "..name.." from "..player(id,"name").."!")
end

function stdust_skill(id)
if rv_stdusttime[id]==1 then
local x,y=player(id,"x"),player(id,"y")
parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 255 0 0")
parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 0 255 0")
parse("effect \"colorsmoke\" "..x.." "..y.." 100 128 0 0 255")
k=0
h=0
for l = 1, 5 do
	if k==250 then
	k=0
	end
	for i = 1, 5 do
	if h==250 then
	h=0
	end
	parse("explosion "..((x+k)-100).." "..((y+h)-100).." \"60\" \"0\" "..id)
	h=h+50
	end
	k=k+50
end
if player(id,"exists") and rv_stdusttime[id]==1 then
		for pl = 1, 24 do
			if player(pl,"exists") and rv_hp[pl]>=1 and no_attack(pl)==false and id~=pl then
				local dist = math.sqrt((player(pl,'x')-player(id,"x"))^2 + (player(pl,'y')-player(id,"y"))^2)
				if dist<=140 and rv_fishstate[id]==0 and rv_fishstate[pl]==0 and ((rv_level[id]-rv_level[pl]<=20) or rv_warliker[pl]>=1) and rv_godmod[pl]==false and rv_godmod[id]==false and rv_level[pl]>=21 and rv_level[id]>=21 then
					if rv_team[id]==rv_team[pl] and (rv_team[id]~=0 and rv_team[pl]~=0) and (c_suginami(id)==false and c_akihabara(id)==false and c_nakano(id)==false) then
					hudtext2(id,18,"255000000","You cant attack your team member!",0,415)
					parse('hudtxtalphafade '..id..' 18 7000 0.0')
					elseif (rv_clan[id]==rv_clan[pl] and (rv_clan[id]~=0 and rv_clan[pl]~=0) and (c_suginami(id)==true or c_akihabara(id)==true or c_nakano(id)==true)) then
					hudtext2(id,18,"255000000","You cant attack your legion member here!",0,415)
					parse('hudtxtalphafade '..id..' 18 7000 0.0')
					else
						local dmgs=(5000+rv_damage[id])+(rv_matk[id]-rv_mdef[id])
						if dmgs<1 then
						dmgs=1
						end
						if rv_hp[pl]>dmgs then
						rv_hp[pl]=rv_hp[pl]-dmgs
						HurtHud(pl,id)
						parse("shake "..pl.." 10")
						else
						parse("customkill "..id.." \"Star Dust Rain\" "..pl)
							if (rv_qid[id]>=11 and rv_qid[id]<=20 and rv_qreq[id]~=0 and rv_qname[id]~="") then
								if rv_qprog[id]+1>=rv_qreq[id] then
									qcom_msg(id)
									rv_qcomp[id]=true
									rv_qprog[id]=rv_qprog[id]+1
								else
									rv_qprog[id]=rv_qprog[id]+1
								end
							end
						end
						rv_warliker[id]=300
					end
				end
			end
		end
		ot=object(0,"table")
		for k=1,#ot do
			if object(ot[k],"exists") and object(ot[k],"health")>0 and object(ot[k],"type")==30 and math.sqrt((object(ot[k],"x")-player(id,"x"))^2+(object(ot[k],"y")-player(id,"y"))^2)<(140)then
				if ((rv_qid[id]>=1 and rv_qid[id]<=10) or (rv_qid[id]>=21 and rv_qid[id]<=30)) and rv_qreq[id]~=0 and rv_qname[id]~="" then
					if rv_qprog[id]+1>=rv_qreq[id] then
						qcom_msg(id)
						rv_qcomp[id]=true
						rv_qprog[id]=rv_qreq[id]
					else
						rv_qprog[id]=rv_qprog[id]+1
					end
				end
				if rv_dexp[id]>=1 then
				rv_exp[id]=rv_exp[id]+20
				else
				rv_exp[id]=rv_exp[id]+20
				end
				parse("killobject "..ot[k])
			end
		end
	local m=mon_img
		if mon_img~=nil then
		local dist = math.sqrt((object(m,'x')-player(id,"x"))^2 + (object(m,'y')-player(id,"y"))^2)
			if dist<=150 then
				if mon_hp>(rv_damage[id]*10)+(rv_matk[id]*20) then
				mon_hp=mon_hp-(rv_damage[id]*10)+(rv_matk[id]*20)
				elseif mon_hp<(rv_damage[id]*10)+(rv_matk[id]*20) then
				reward_boss(m,id,x,y)
				end
			end
		end
	end
end
rv_stdusttime[id]=rv_stdusttime[id]-1
end

function msg_admin(id,pl,txt)
if txt:find("@C") then
	local ss=string.find(txt, "@C")
	txt=txt:gsub(txt:sub(ss,ss),"")
end
for pl = 1, 24 do
	if player(pl,"exists") and rv_admina[pl]==true then
	rv_msg2(pl,"192192192",player(id,"name").." use command "..txt)
	end
end
end

function detect_item(id)
local itemlist=item(0,"table")
for _,i in ipairs(itemlist) do
	if item(i,"x")==rv_tilex[id] and item(i,"y")==rv_tiley[id] then
	itemm=itemm+1
	end
end
end

rv_pdark=0

function star_dark_event()
rv_pdark=0
for id = 1, 24 do
	if player(id,"exists") and player(id,"health")>0 and dark_event(id)==true and tile(player(id,"tilex"),player(id,"tiley"),"frame")==34 then
		rv_pdark=rv_pdark+1
	end
end
if rv_pdark>=2 then
	rv_msg("200200200","Dark Room Event has been started!")
	for id = 1, 24 do
		if player(id,"exists") and player(id,"health")>0 and dark_event(id)==true and tile(player(id,"tilex"),player(id,"tiley"),"frame")==34 then
			local x=math.random(182,194)
			local y=math.random(86,96)
			parse("setpos "..id.." "..((x*32)+16).." "..((y*32)+16))
			parse("equip "..id.." 1")
			parse("setweapon "..id.." 1")
		end
	end
else
	parse("trigger dark_but")
	rv_pdark=0
end
end

function ExpKill(killer)
if rv_dexp[killer]>=1 then
rv_exp[killer]=rv_exp[killer]+50
else
rv_exp[killer]=rv_exp[killer]+25
end
end

function DeathDrop(victim)
local x=player(victim,"tilex")
local y=player(victim,"tiley")
primadrop=math.floor(drop/100)
drop=drop-(primadrop*100)
secondrop=math.floor(drop/50)
drop=drop-(secondrop*50)
golddrop=math.floor(drop/10)
drop=drop-(golddrop*10)
moneydrop=math.floor(drop/5)
drop=drop-(moneydrop*5)
if primadrop>=1 then
for i = 1, primadrop do
parse("spawnitem \"61\" "..x.." "..y)
end
end
if secondrop>=1 then
for i = 1, secondrop do
parse("spawnitem \"62\" "..x.." "..y)
end
end
if golddrop>=1 then
for i = 1, golddrop do
parse("spawnitem \"68\" "..x.." "..y)
end
end
if moneydrop>=1 then
for i = 1, moneydrop do
parse("spawnitem \"67\" "..x.." "..y)
end
end
if drop>=1 then
for i = 1, drop do
parse("spawnitem \"66\" "..x.." "..y)
end
end
primadrop=0
secondrop=0
golddrop=0
moneydrop=0
drop=0
end

function Farming(id)
local wpn = player(id,"weapontype")
if rv_stats[id][7]>=25 then
	eq=math.floor(rv_stats[id][7]/25)
else
	eq=0
end
if (wpn==69 or wpn==50 or wpn==85) and rv_sting[id]<=0 then
local farm=math.random(1,21-eq)
local food=math.random(30,80)
	if wpn==69 then
		rv_food[id]=rv_food[id]+10000
		if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
			rv_qprog[id]=rv_qprog[id]+10000
			if rv_qprog[id]>=rv_qreq[id] then
				rv_qprog[id]=rv_qreq[id]
				qcom_msg(id)
			end
		end
		hudtext2(id,20,"200200200","You get 10000 Foods",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
	else
		if farm==1 or farm==2 or farm==3 or farm==4 then
			if rv_stats[id][7]>=5 then food=food+math.floor(rv_stats[id][7]/5) end
			if rv_spcuser[id]==true then food=food+15 end
			if rv_pickaxe[id]==true then food=food+math.floor(food/10) end
			rv_food[id]=rv_food[id]+food
			if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
				rv_qprog[id]=rv_qprog[id]+food
				if rv_qprog[id]>=rv_qreq[id] then
					rv_qprog[id]=rv_qreq[id]
					qcom_msg(id)
				end
			end
		hudtext2(id,20,"200200200","You get "..food.." Foods",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
		end
	end
	hudtext2(id,21,"075255000","Farming..",290,130)
	parse('hudtxtalphafade '..id..' 21 5000 0.0')
end
end

function Chopping(id)
local wpn = player(id,"weapontype")
if rv_stats[id][7]>=25 then
	eq=math.floor(rv_stats[id][7]/25)
else
	eq=0
end
if (wpn==69 or wpn==50 or wpn==85) and rv_sting[id]<=0 then
local chop=math.random(1,23-eq)
local wood=math.random(30,80)
	if wpn==69 then
		rv_wood[id]=rv_wood[id]+10000
		if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
			rv_qprog[id]=rv_qprog[id]+10000
			if rv_qprog[id]>=rv_qreq[id] then
				rv_qprog[id]=rv_qreq[id]
				qcom_msg(id)
			end
		end
		hudtext2(id,20,"200200200","You get 10000 Woods",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
	else
		if chop==1 or chop==2 or chop==3 then
			if rv_stats[id][7]>=5 then wood=wood+math.floor(rv_stats[id][7]/5) end
			if rv_spcuser[id]==true then wood=wood+15 end
			if rv_pickaxe[id]==true then wood=wood+math.floor(wood/10) end
			rv_wood[id]=rv_wood[id]+wood
			if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
				rv_qprog[id]=rv_qprog[id]+wood
				if rv_qprog[id]>=rv_qreq[id] then
					rv_qprog[id]=rv_qreq[id]
					qcom_msg(id)
				end
			end
		hudtext2(id,20,"200200200","You get "..wood.." Woods",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
		end
	end
	hudtext2(id,21,"075255000","Chopping..",290,130)
	parse('hudtxtalphafade '..id..' 21 5000 0.0')
end
end

function Quarrying(id)
local wpn = player(id,"weapontype")
if rv_stats[id][7]>=25 then
	eq=math.floor(rv_stats[id][7]/25)
else
	eq=0
end
if (wpn==69 or wpn==50 or wpn==85) and rv_sting[id]<=0 then
local breaks=math.random(1,23-eq)
local stone=math.random(30,80)
	if wpn==69 then
		rv_stone[id]=rv_stone[id]+10000
		if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
			rv_qprog[id]=rv_qprog[id]+10000
			if rv_qprog[id]>=rv_qreq[id] then
				rv_qprog[id]=rv_qreq[id]
				qcom_msg(id)
			end
		end
		hudtext2(id,20,"200200200","You get 10000 Stones",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
	else
		if breaks==1 or breaks==2 or breaks==3 then
			if rv_stats[id][7]>=5 then stone=stone+math.floor(rv_stats[id][7]/5) end
			if rv_spcuser[id]==true then stone=stone+15 end
			if rv_pickaxe[id]==true then stone=stone+math.floor(stone/10) end
		rv_stone[id]=rv_stone[id]+stone
			if rv_qid[id]>=41 and rv_qid[id]<=60 and rv_qcomp[id]==false and rv_qreq[id]~=0 and rv_qname[id]~="" then
				rv_qprog[id]=rv_qprog[id]+stone
				if rv_qprog[id]>rv_qreq[id] then
					rv_qprog[id]=rv_qreq[id]
					qcom_msg(id)
				end
			end
		hudtext2(id,20,"200200200","You get "..stone.." Stones",380,405)
		parse('hudtxtalphafade '..id..' 20 5000 0.0')
		end
	end
	hudtext2(id,21,"075255000","Quarrying..",290,130)
	parse('hudtxtalphafade '..id..' 21 5000 0.0')
end
end

function Catch_fish(id)
local x,y = player(id,"tilex"),player(id,"tiley")
if rv_rod[id]==true then
	if rv_bait[id]>=1 then
		if rd_horse[id]==0 and rv_kyubitime[id]<=0 then
			if rv_fishstate[id]>=1 then
				rv_fishing[id]=0
				rv_fishstate[id]=0
				rv_msg2(id,"255000000","You stop fishing!")
				hudtext2(id,21,"075255000","",290,130)
				parse("speedmod "..id.." "..rv_speedmod[id])
			else
				if player(id,"health")>0 and tile(x,y,"frame")==68 and konoha_forest(id)==true then
					rv_fishing[id]=5
					rv_fishstate[id]=1
					rv_msg2(id,"000255000","You start fishing..")
					hudtext2(id,21,"075255000","Fishing..",290,130)
					parse("speedmod "..id.." -100")
				else
					rv_msg2(id,"255000000","You cant do fishing here!")
				end
			end
		else
			rv_msg2(id,"255000000","You cant start fishing in this situation!")
		end
	else
		rv_msg2(id,"255000000","You dont have any Bait!")
	end
else
	rv_msg2(id,"255000000","You dont have Fishing Rod!")
end
end

function Get_fish(id)
if rv_fishing[id]<=-1 then
	rv_fish[id]=rv_fish[id]+1
	rv_msg2(id,"000255000","You catch a fish!")
	rv_fishing[id]=5
else
	rv_msg2(id,"255000000","The fish already ran away!")
end
end

function Detect_fish(id)
local fish=math.random(1,90-math.floor(rv_stats[id][6]/10))
if rv_fishstate[id]==1 and rv_fishing[id]>=0 then
	if rv_bait[id]>=1 then
		if tile(player(id,"tilex"),player(id,"tiley"),"frame")==68 and konoha_forest(id)==true then
			rv_bait[id]=rv_bait[id]-1
			if fish>=10 and fish<=17 then
			rv_bones[id]=rv_bones[id]+1
			rv_msg2(id,"000255000","You get 1 Dead Monster Bones floating on the water!")
			end
			if fish>=20 and fish<=27 then
			rv_berry[id]=rv_berry[id]+1
			rv_msg2(id,"000255000","You get 1 Berry floating on the water!")
			end
			if fish>=30 and fish<=33 then
			rv_bones[id]=rv_bones[id]+1
			rv_msg2(id,"000255000","You get 10 Gold floating on the water!")
			end
			if fish>=40 and fish<=50 then
			rv_fishing[id]=-4
			rv_msg2(id,"000255000","You detect a fish! Left click with knife to catch the fish!")
			end
		else
			rv_fishing[id]=0
			rv_fishstate[id]=0
			rv_msg2(id,"255000000","You must fishing on the water!")
			hudtext2(id,21,"075255000","",290,130)
			parse("speedmod "..id.." "..rv_speedmod[id])
		end
	else
		rv_msg2(id,"255000000","You run out of your baits! Buy more baits to continue!")
		parse("speedmod "..id.." "..rv_speedmod[id])
		hudtext2(id,21,"075255000","",290,130)
		rv_fishing[id]=0
		rv_fishstate[id]=0
	end
end
end

function splash_stinger(id)
local adir=-20
for i = 1, 10 do
parse("spawnprojectile "..id.." \"75\" "..player(id,"x").." "..player(id,"y").." \"100000\" "..player(id,"rot")+adir)
adir=adir+4
end
end

function kiri_jutsu(id)
local x,y = player(id,"x"),player(id,"y")
for i = 1, 5 do
parse("effect \"smoke\" "..x.." "..y.." \"100\" 128")
end
local dera=0
rv_kirix[id]=x
rv_kiriy[id]=y
dera=0
end

function kiri_no_jutsu(id)
local x = math.random(-100,100)
local y = math.random(-100,100)
parse("effect \"smoke\" "..(rv_kirix[id]+x).." "..(rv_kiriy[id]+y).." \"40\" 40")
end

function physical_burst(id)
if player(id,"speedmod")==rv_speedmod[id] and rd_horse[id]==0 and rv_pburst[id][4]<=0 and rv_kyubitime[id]<=0 then
	if rv_energy[id]>=300 then
	rv_pburst[id][2]=3
	parse("speedmod "..id.." "..rv_speedmod[id]+50)
	pburst_glow(id)
	rv_energy[id]=rv_energy[id]-300
	radiusmsg(c.."255255255"..player(id,"name").." use Physical Burst!",player(id,"x"),player(id,"y"),320,240,"255255255")
	else
		rv_msg2(id,"255000000","You dont have enough chakra!")
	end
else
	rv_msg2(id,"255000000","You cant use this skill is this situation!")
end
end

function physical_full_burst(id)
if player(id,"speedmod")==rv_speedmod[id] and rd_horse[id]==0 and rv_pburst[id][4]<=0 and rv_kyubitime[id]<=0 then
	if rv_energy[id]>=900 then
	rv_pburst[id][4]=7
	parse("speedmod "..id.." 100")
	pburst_glow(id)
	rv_energy[id]=rv_energy[id]-900
	radiusmsg(c.."255255255"..player(id,"name").." use Physical Full Burst!",player(id,"x"),player(id,"y"),320,240,"255255255")
	else
		rv_msg2(id,"255000000","You dont have enough chakra!")
	end
else
	rv_msg2(id,"255000000","You cant use this skill is this situation!")
end
end

function pburst_glow(id)
	rv_pburstimg[id]=image("gfx/sprites/flare2.bmp",0,0,100+id)
	imagecolor(rv_pburstimg[id],255,0,0)
	imageblend(rv_pburstimg[id],1)
	imagealpha(rv_pburstimg[id],1)
end

function pburst_clear(id)
	freeimage(rv_pburstimg[id])
	rv_pburstimg[id]=nil
end

function Spawn_Vortigaunt()
for i = 1,5 do
SpawnVortigaunt()
end
rv_msg("000255000","Army of Vortigaunt appear on Otogakure Cave!@C")
end

function SpawnVortigaunt()
local x=math.random(87,123)
local y=math.random(28,31)
local rot=math.random(0,360)
if tile(x,y,"walkable")==true then
parse("spawnnpc "..(4).." "..x.." "..y.." "..rot)
else
SpawnVortigaunt()
end
end

function SpawnZombie()
local x=math.random(0,40)
local y=math.random(59,99)
local rot=math.random(0,360)
if tile(x,y,"walkable")==true then
parse("spawnnpc "..(1).." "..x.." "..y.." "..rot)
else
SpawnZombie()
end
end

function SetEnergy(id)
rv_maxenergy[id]=(1000+(rv_stats[id][4]*10))
if rv_donator[id]==true then
rv_maxenergy[id]=rv_maxenergy[id]+2500
elseif rv_spcuser[id]==true then
rv_maxenergy[id]=rv_maxenergy[id]+500
end
if player(id,"usgn")==107349 then
rv_maxenergy[id]=rv_maxenergy[id]+5000
end
if player(id,"team")==1 then
rv_maxenergy[id]=rv_maxenergy[id]+5000
end
end

function SetHealth(id)
rv_hpp[id]=1000
rv_hpp[id]=rv_hpp[id]+((1200*rv_reincarnation[id])+(400*rv_attribute[id])+(700*rv_class[id]))
if rv_spcuser[id]==true then
rv_hpp[id]=rv_hpp[id]+3000
end
if player(id,"gasmask")==true then
rv_hpp[id]=rv_hpp[id]+300
end
if player(id,"nightvision")==true then
rv_hpp[id]=rv_hpp[id]+300
end
if player(id,"defusekit")==true then
rv_hpp[id]=rv_hpp[id]+300
end
if player(id,"armor")==205 then
rv_hpp[id]=rv_hpp[id]+500
end
if player(id,"armor")==206 then
rv_hpp[id]=rv_hpp[id]+100000
rv_hp[id]=rv_hp[id]+100000
end
if player(id,"team")==1 then
rv_hpp[id]=rv_hpp[id]+100000
rv_hp[id]=rv_hp[id]+100000
end
if rv_usgnid[id]==107349 then
rv_hpp[id]=rv_hpp[id]+1000000
rv_hp[id]=rv_hp[id]+1000000
end
if rv_donator[id]==true then
rv_hpp[id]=rv_hpp[id]+5000
rv_hp[id]=rv_hp[id]+5000
end
if rv_wing[id]==true then
rv_hpp[id]=rv_hpp[id]+3000
end
if belongs_to_table(playerweapons(id),41) then
rv_hpp[id]=rv_hpp[id]+400
end
if rv_stats[id][3]>=1 then
rv_hpp[id]=rv_hpp[id]+(100*rv_stats[id][3])
end
if rv_pet[id]==2 then
rv_hpp[id]=rv_hpp[id]+200
end
if rv_pet[id]==4 then
rv_hpp[id]=rv_hpp[id]+100
end
rv_hpp[id]=rv_hpp[id]+rv_hppup[id]
rv_hpp[id]=rv_hpp[id]+(50*rv_level[id])
--
local cl = rv_clan[id]
if cl >= 1 then
local req = 400
local lvl = 1
local point = c_point[cl]
local ter = 0
for i = 1, 30 do
	if point-req>=0 then
	point=point-req
	req=req+req
	lvl=lvl+1
	end
end
for i = 1, 3 do
	if c_owned[i]==c_name[cl] then
	ter=ter+1
	end
end
local hp = math.floor(lvl/3)
hp=hp+ter
hp1=math.floor(rv_hpp[id]*hp/100)
rv_hpp[id]=rv_hpp[id]+hp1
end
--
local t=rv_team[id]
if t>=1 and t<=6 then
	rv_hpp[id]=rv_hpp[id]+math.floor(rv_hpp[id]*(teamp[t]/100))
elseif t==7 then
	rv_hpp[id]=rv_hpp[id]+math.floor(rv_hpp[id]*0.05)
end
if rv_hp[id]>=rv_hpp[id] then
rv_hp[id]=rv_hpp[id]
end
end
		
function mouse_img(id,imga)
	if Player[id].mx == nil then Player[id].mx = 0 end
	if Player[id].my == nil then Player[id].my = 0 end
	local x1 = math.floor(Player[id].mx / 32)
	local y1 = math.floor(Player[id].my / 32)
	if entity(x1,y1,"exists") then
		if entity(x1,y1,"typename") == "Func_DynWall" then
			parse('hudtxt2 '..id..' 0 "'..c..'255000000Entity: '..c..'255220000'..entity(x1,y1,'name')..'" '..Player[id].sx..' '..(Player[id].sy + 20)..' 1')
			Player[id].use = entity(x1,y1,"name")
		else
			parse('hudtxt2 '..id..' 0 ""')
			Player[id].use = false
		end
	else
		parse('hudtxt2 '..id..' 0 ""')
		Player[id].use = false
	end
end

function rasengan(id)
if rv_rasens[id]>=2 and rv_rasens[id]<=100 then
rv_rasens[id]=rv_rasens[id]-1
local rot = player(id,"rot")
if rot < -90 then rot = rot + 360 end
	local angle = math.rad(math.abs( rot + 90 )) - math.pi
	local x = player(id,"x") + math.cos(angle) * 25
	local y = player(id,"y") + math.sin(angle) * 25
	local xx = player(id,"x") + math.cos(angle) * 50
	local yy = player(id,"y") + math.sin(angle) * 50
	local tx,ty = math.floor(x/32),math.floor(y/32)
	rv_rasenrot[id]=rv_rasenrot[id]+15
	if rv_rasenrot[id]>=360 then
		rv_rasenrot[id]=0
	end
	if player(id,"exists") and rv_rasenimg[id]~=nil then
		for pl = 1, 24 do
			if player(pl,"exists") and rv_hp[pl]>=1 and no_attack(pl)==false and id~=pl then
				local dist = math.sqrt((player(pl,'x')-x)^2 + (player(pl,'y')-y)^2)
				if dist<=50 and rv_fishstate[id]==0 and rv_fishstate[pl]==0 and ((rv_level[id]-rv_level[pl]<=20) or rv_warliker[pl]>=1) and rv_godmod[pl]==false and rv_godmod[id]==false and rv_level[pl]>=21 and rv_level[id]>=21 then
					if rv_team[id]==rv_team[pl] and (rv_team[id]~=0 and rv_team[pl]~=0) and (c_suginami(id)==false and c_akihabara(id)==false and c_nakano(id)==false) then
						hudtext2(id,18,"255000000","You cant attack your team member!",0,415)
						parse('hudtxtalphafade '..id..' 18 7000 0.0')
					elseif (rv_clan[id]==rv_clan[pl] and (rv_clan[id]~=0 and rv_clan[pl]~=0) and (c_suginami(id)==true or c_akihabara(id)==true or c_nakano(id)==true)) then
						hudtext2(id,18,"255000000","You cant attack your legion member here!",0,415)
						parse('hudtxtalphafade '..id..' 18 7000 0.0')
					else
						local dmgs=math.floor((rv_damage[id]/55)+(rv_matk[id]/5)-rv_mdef[pl])
						if dmgs<1 then
						dmgs=1
						end
						if rv_hp[pl]>dmgs then
						rv_hp[pl]=rv_hp[pl]-dmgs
						HurtHud(pl,id)
						parse("shake "..pl.." 10")
						rv_rasened[pl]=2
						rv_rasenx[pl]=x
						rv_raseny[pl]=y
						parse("setpos "..pl.." "..x.." "..y)
						UpdateArea(pl)
						else
						parse("customkill "..id.." \"Rasengan\" "..pl)
							if (rv_qid[id]>=11 and rv_qid[id]<=20) then
								if rv_qprog[id]+1>=rv_qreq[id] then
									qcom_msg(id)
									rv_qcomp[id]=true
									rv_qprog[id]=rv_qprog[id]+1
								else
									rv_qprog[id]=rv_qprog[id]+1
								end
							end
						end
						rv_warliker[id]=300
					end
				end
			end
		end
		ot=object(0,"table")
		for k=1,#ot do
			if object(ot[k],"exists") and object(ot[k],"health")>0 and object(ot[k],"type")==30 and math.sqrt((object(ot[k],"x")-x)^2+(object(ot[k],"y")-y)^2)<(50)then
				if ((rv_qid[id]>=1 and rv_qid[id]<=10) or (rv_qid[id]>=21 and rv_qid[id]<=30)) and rv_qreq[id]~=0 and rv_qname[id]~="" then
					if rv_qprog[id]+1>=rv_qreq[id] then
						qcom_msg(id)
						rv_qcomp[id]=true
						rv_qprog[id]=rv_qreq[id]
					else
						rv_qprog[id]=rv_qprog[id]+1
					end
				end
				if rv_dexp[id]>=1 then
				rv_exp[id]=rv_exp[id]+20
				else
				rv_exp[id]=rv_exp[id]+20
				end
				parse("killobject "..ot[k])
			end
		end
	local m=mon_img
		if mon_img~=nil then
		local dist = math.sqrt((object(m,'x')-x)^2 + (object(m,'y')-y)^2)
			if dist<=150 then
				local dmgs=math.floor((rv_damage[id]/5)+(rv_matk[id]/2))
				if mon_hp>dmgs then
				mon_hp=mon_hp-dmgs
				elseif mon_hp<dmgs then
				reward_boss(m,id,x,y)
				end
				if (rv_qid[id]>=31 and rv_qid[id]<=40 and rv_qreq[id]~=0 and rv_qname[id]~="" and rv_qcomp[id]==false) then
					if rv_qprog[id]+dmgs>=rv_qreq[id] then
						qcom_msg(id)
						rv_qcomp[id]=true
						rv_qprog[id]=rv_qreq[id]
					else
						rv_qprog[id]=rv_qprog[id]+dmgs
					end
				end
			end
		end
	end
	if x > 0 and y > 0 and tile(tx,ty,"walkable")==true and x < map("xsize") * 32 and y < map("ysize") * 32 then
		parse("setpos "..id.." "..x.." "..y)
		UpdateArea(id)
		imagepos(rv_rasenimg[id],xx,yy,rv_rasenrot[id])
	else
		imagepos(rv_rasenimg[id],x,y,rv_rasenrot[id])
	end
elseif rv_rasens[id]==1 then
	rv_rasens[id]=-150
	if rv_rasenimg[id]~=nil then
	freeimage(rv_rasenimg[id])
	rv_rasenimg[id]=nil
	end
end
end

function wallhack(id)
local rot = player(id,"rot")
if rot < -90 then rot = rot + 360 end
local angle = math.rad(math.abs( rot + 90 )) - math.pi
local x = player(id,"x") + math.cos(angle) * rv_wallhack[id]
local y = player(id,"y") + math.sin(angle) * rv_wallhack[id]
if x > 0 and y > 0 and x < map("xsize") * 32 and y < map("ysize") * 32 then
	parse("setpos "..id.." "..x.." "..y)
end
end

function standartrad(angle) 
	if (angle<=90) then 
		angle = (angle + 360) 
	end 
	return math.rad(math.abs( angle + 90 ))-math.pi 
end

t_pl = 0
t_id = {}

for i = 1, 24 do
	t_id[i]=-1
end

function detect_pl()
t_pl = 0
t_id = {}
for i = 1, 24 do
	t_id[i]=-1
end
for id = 1, 24 do
	if player(id,"exists") then
		t_pl=t_pl+1
		t_id[id]=1
	end
end
end

function random_prize()
local id = math.random(1,24)
local gold = math.random(1000,5000)
	if t_id[id]==1 and player(id,"exists") and player(id,"team")~=0 then
		rv_msg("000000255","Congratulations! "..player(id,"name").." WIN a random event and get "..gold.." Golds!")
		rv_gain[id]=rv_gain[id]+gold
	else
		random_prize()
	end
end

function zombie_gut(idd,id)
local rot1 = object(id,"rot")
if rot1 < -90 then rot1 = rot1 + 360 end
local angle = math.rad(math.abs( rot1 + 90 )) - math.pi
local x = object(id,"x") + math.cos(angle) * 30
local y = object(id,"y") + math.sin(angle) * 30
parse("spawnprojectile "..id.." 86 "..x.." "..y.." 90000 "..rot1)
end

function hc_check_for_smileys(p, message)
    for word in string.gmatch(message, "[^%s]+") do
        for smiley, emoticon in pairs(HC_EMOTICONS) do
            if word:match(smiley) then
                hc_show_emoticon(p, emoticon)
                return
            end
        end
    end
end

function hc_show_emoticon(p, emoticon)
    if hc_emoticons[p].emoticon ~= nil then
        freeimage(hc_emoticons[p].emoticon)
    else
        table.insert(hc_smiling_players, p)
        hc_emoticons[p].speechbubble = image(HC_EMOTICON_PATH .. "speechbubble.png", 0, 0, 200 + p)
        hc_emoticons[p].alpha = HC_EMOTICON_FADE_IN_STEP
    end
    hc_emoticons[p].smiley_time = os.time()
    hc_emoticons[p].emoticon = image(HC_EMOTICON_PATH .. emoticon .. ".png", 0, 0, 200 + p)
    imagealpha(hc_emoticons[p].speechbubble, hc_emoticons[p].alpha)
    imagealpha(hc_emoticons[p].emoticon, hc_emoticons[p].alpha)
end

userstats = {}

-- Get Player Rank from userstats.dat by MikuAuahDark (MieKuahDark :v)
function Int(a,b,c,d)
	return a*16777216+b*65536+c*256+d
end

function GetUserStatsRank(id,usgn)
	local t=io.open("sys/stats/userstats.dat","rb")
	local a=t:read("*a")
	t:close()
	a=a:sub(17)
	local temp={
		["isexists"]=false,
		["score"]=0,
		["frags"]=0,
		["deaths"]=0,
		["time"]=0
	}
	repeat
		local newline=a:find("\n")
		if newline==nil then break end
		a=a:sub(newline+1)
		if Int(a:sub(4,4):byte(),a:sub(3,3):byte(),a:sub(2,2):byte(),a:sub(1,1):byte())==usgn then
			temp.isexists=true
			a=a:sub(5)
			temp.score=Int(a:sub(4,4):byte(),a:sub(3,3):byte(),a:sub(2,2):byte(),a:sub(1,1):byte())
			a=a:sub(5)
			temp.frags=Int(a:sub(4,4):byte(),a:sub(3,3):byte(),a:sub(2,2):byte(),a:sub(1,1):byte())
			a=a:sub(5)
			temp.deaths=Int(a:sub(4,4):byte(),a:sub(3,3):byte(),a:sub(2,2):byte(),a:sub(1,1):byte())
			a=a:sub(5)
			temp.time=Int(a:sub(4,4):byte(),a:sub(3,3):byte(),a:sub(2,2):byte(),a:sub(1,1):byte())
			kill=temp.frags
			death=temp.deaths
			times=temp.time
			day=math.floor(times/86400)
			times=times-(86400*day)
			hour=math.floor(times/3600)
			times=times-(3600*hour)
			minute=math.floor(times/60)
			times=times-(60*minute)
			break
		else
			a=a:sub(21)
		end
	until false
	return temp
end