rv_pet = Array(24,0)
rv_pets = Array(24,"Nothing")
rv_petimg = Array(24,nil)
rv_petx = Array(24,0)
rv_pety = Array(24,0)
rv_petsk = Array(24,0)

function SetPet(id)
if rv_petimg[id]~=nil then
freeimage(rv_petimg[id])
rv_petimg[id]=nil
end
rv_petimg[id]=image("gfx/-revo-/pet"..rv_pet[id]..".png",0,0,0)
imagepos(rv_petimg[id],player(id,"x"),player(id,"y"),0)
rv_petx[id]=player(id,"x")
rv_pety[id]=player(id,"y")
end

function pet_follow(id)
if rv_pet[id]==5 or rv_pet[id]==6 then
	local rot=math.random(-5,5)
	local movex=math.random(-64,64)
	local movey=math.random(-64,64)
	rv_petx[id]=player(id,"x")+movex
	rv_pety[id]=player(id,"y")+movey
	tween_rotateconstantly(rv_petimg[id],rot)
	tween_move(rv_petimg[id],1000,rv_petx[id],rv_pety[id])
elseif rv_pet[id]~=0 and rv_petimg[id]~=nil then
	local movex=math.random(-64,64)
	local movey=math.random(-64,64)
	rv_petx[id]=player(id,"x")+movex
	rv_pety[id]=player(id,"y")+movey
	tween_move(rv_petimg[id],1000,rv_petx[id],rv_pety[id])
end
end

function pet_teleport(id)
if rv_pet[id]~=0 and rv_petimg[id]~=nil then
	local movex=math.random(-50,50)
	local movey=math.random(-50,50)
	local dist = math.sqrt((player(id,'x')-rv_petx[id])^2 + (player(id,'y')-rv_pety[id])^2)
	if dist>=500 then
	rv_petx[id]=player(id,"x")+movex
	rv_pety[id]=player(id,"y")+movey
	imagepos(rv_petimg[id],player(id,'x'),player(id,'y'),0)
	else
	pet_follow(id)
	end
end
end

function pet_attack(src,id)
if rv_pet[src]==1 or rv_pet[src]==3 then
	if player(id,"health")>0 then
		imagepos(rv_petimg[src],player(id,'x'),player(id,'y'),0)
		parse("explosion "..player(id,'x').." "..player(id,'y').." \"50\" \"0\" "..src)
		rv_petsk[src]=-120
		if rv_pet[src]==1 then
			radiusmsg(c.."255255255"..player(src,"name").."'s Naruto use Rasengan!",player(src,"x"),player(src,"y"),320,240,"255255255")
		else
			radiusmsg(c.."255255255"..player(src,"name").."'s Sasuke use Chidori!",player(src,"x"),player(src,"y"),320,240,"255255255")
		end
		local dmg=800+math.floor(rv_damage[src]/5)
		if dmg<1 then dmg=1 end
		if rv_hp[id]>=dmg then
			rv_hp[id]=rv_hp[id]-dmg
		elseif rv_hp[id]<=dmg then
			if rv_pet[src]==1 then
			parse("customkill "..src.." \"Pet's Rasengan\" "..id)
			else
			parse("customkill "..src.." \"Pet's Chidori\" "..id)
			end
		end
	end
end
if rv_pet[src]==5 then
	if player(id,"health")>0 then
		imagepos(rv_petimg[src],player(id,'x'),player(id,'y'),0)
		parse("explosion "..player(id,'x').." "..player(id,'y').." \"50\" \"0\" "..src)
		radiusmsg(c.."255255255"..player(src,"name").."'s Little Dark use Dark Blow!",player(src,"x"),player(src,"y"),320,240,"255255255")
		rv_petsk[src]=-120
		local dmg=1000+math.floor(rv_damage[src]/4)
		if dmg<1 then dmg=1 end
		if rv_hp[id]>=dmg then
			rv_hp[id]=rv_hp[id]-dmg
		elseif rv_hp[id]<=dmg then
			parse("customkill "..src.." \"Pet's Dark Blow\" "..id)
		end
	end
end
if rv_pet[src]==6 then
	if player(id,"health")>0 then
		imagepos(rv_petimg[src],player(id,'x'),player(id,'y'),0)
		parse("explosion "..player(id,'x').." "..player(id,'y').." \"50\" \"0\" "..src)
		radiusmsg(c.."255255255"..player(src,"name").."'s Santa Akatsuki use Santa Strike!",player(src,"x"),player(src,"y"),320,240,"255255255")
		rv_petsk[src]=-130
		local dmg=1000+math.floor(rv_damage[src]/3.5)
		if dmg<1 then dmg=1 end
		if rv_hp[id]>=dmg then
			rv_hp[id]=rv_hp[id]-dmg
		elseif rv_hp[id]<=1000+dmg then
			parse("customkill "..src.." \"Pet's Santa Strike\" "..id)
		end
	end
end
end

function pet_act(id)
if rv_pet[id]==2 or rv_pet[id]==4 then
	if rv_pet[id]==2 then
		radiusmsg(c.."255255255"..player(id,"name").."'s Sakura use Enkaku Chiyu!",player(id,"x"),player(id,"y"),320,240,"255255255")
		rv_hp[id]=rv_hp[id]+math.floor(rv_hpp[id]/5)
		rv_petsk[id]=-800
	else
		rv_petsk[id]=250
		radiusmsg(c.."255255255"..player(id,"name").."'s Kakashi use Sharingan!",player(id,"x"),player(id,"y"),320,240,"255255255")
	end
end
if rv_pet[id]==5 then
	radiusmsg(c.."255255255"..player(id,"name").."'s Little Dark use Dark Bless!",player(id,"x"),player(id,"y"),320,240,"255255255")
	rv_hp[id]=rv_hp[id]+math.floor(rv_hpp[id]/4)
	rv_petsk[id]=-700
end
if rv_pet[id]==6 then
	radiusmsg(c.."255255255"..player(id,"name").."'s Santa Akatsuki use X-mas Bless!",player(id,"x"),player(id,"y"),320,240,"255255255")
	rv_hp[id]=rv_hp[id]+math.floor(rv_hpp[id]/6)
	rv_energy[id]=rv_energy[id]+math.floor(rv_maxenergy[id]/4)
	rv_petsk[id]=-900
end
end